﻿; bouton ->degradé
; fenetre -> choix icone a integrer


Enumeration
  #Window_fonts = 100
  
  #Text_font_1
  #ListView_font_listfonts
  #ListView_font_style
  #Text_font_2
  #trackbar_font_taille
  #expli_font_taille
  #Text_font_3
  #Text_font_test
  #Button_font_ok
  #Button_font_cancel
  #Button_font_couleur_texte
  #Button_font_couleur_fond_texte
  #Button_font_couleur_gadget
  
  #Font_Button_font_ok
  #Font_Button_font_cancel
  #font_test
  
EndEnumeration

Global NewList  FaceName.s()
Global retour_nom_font.s
Global retour_taille_font.l
Global retour_style_font.l
Global retour_couleur_texte.l
Global retour_couleur_fond_texte.l = GetSysColor_(#COLOR_BTNFACE)
Global retour_couleur_fond_gadget.l = GetSysColor_(#COLOR_BTNFACE)

Global last_image.l

Procedure EnumFontFamExProc(*lpelfe.ENUMLOGFONTEX,*lpntme.NEWTEXTMETRICEX,FontType,lParam)
   FaceName$ = PeekS(@*lpelfe\elfFullName)
       
   Select FontType
      Case #TRUETYPE_FONTTYPE
      Type$ + " [TT]"
   EndSelect
   
   ForEach FaceName()
      If FaceName() = FaceName$ + Type$ : Goto SkipFont : EndIf
   Next
   
   AddElement(FaceName())   
   FaceName() = FaceName$
   Type$ = ""
   SkipFont:
   
   ProcedureReturn #True
 EndProcedure 
 
Procedure OpenWindow_Window_fonts()
  If OpenWindow(#Window_fonts, 473, 158, 494, 424, "Fonts", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
    If UseGadgetList(WindowID(#Window_fonts))
      TextGadget(#Text_font_1, 0, 5, 165, 20, "Nom de la font :", #PB_Text_Center)
      ListViewGadget(#ListView_font_listfonts, 0, 25, 275, 195)
      ListViewGadget(#ListView_font_style, 280, 25, 115, 195 , #PB_ListView_MultiSelect)
      AddGadgetItem(#ListView_font_style , -1  ,"Normal")
      AddGadgetItem(#ListView_font_style , -1  ,"Italique")
      AddGadgetItem(#ListView_font_style , -1  ,"Gras")
      AddGadgetItem(#ListView_font_style , -1  ,"Barré")
      AddGadgetItem(#ListView_font_style , -1  ,"Souligné")
      TextGadget(#Text_font_2, 280, 5, 115, 20, "Style :", #PB_Text_Center)
      TrackBarGadget(#trackbar_font_taille , 400 , 25 , 90 , 175 , 6 , 100 , #PB_TrackBar_Vertical)
      TextGadget( #expli_font_taille , 400,200,90,20,"6")
      TextGadget(#Text_font_3, 400, 5, 90, 20, "Taille :", #PB_Text_Center)
;      TextGadget(#Text_font_test, 5, 245, 480, 80, "TEST 1234 @ $", #PB_Text_Border|#PB_Text_Center)
      ButtonImageGadget(#Text_font_test, 5, 245, 480, 80, 0)
      ButtonGadget(#Button_font_ok, 10, 350, 105, 60, "OK")
      ButtonGadget(#Button_font_cancel, 380, 350, 105, 60, "Cancel")
      ButtonGadget(#Button_font_couleur_texte, 180, 340, 140, 20, "Couleur du texte")
      ButtonGadget(#Button_font_couleur_fond_texte, 180, 365, 140, 20, "Couleur du fond du texte")
      ButtonGadget(#Button_font_couleur_gadget, 180, 390, 140, 20, "couleur du gadget")
      ; Gadget Fonts
      SetGadgetFont(#Button_font_ok, LoadFont(#Font_Button_font_ok, "Microsoft Sans Serif", 16, #PB_Font_Bold|#PB_Font_HighQuality))
      SetGadgetFont(#Button_font_cancel, LoadFont(#Font_Button_font_cancel, "Microsoft Sans Serif", 16, #PB_Font_Bold|#PB_Font_HighQuality))
    EndIf
  EndIf
EndProcedure

Procedure check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
  Dim font_style(10)
  font_style(0) = 0
  font_style(1) = #PB_Font_Italic
  font_style(2) = #PB_Font_Bold
  font_style(3) = #PB_Font_StrikeOut
  font_style(4) = #PB_Font_Underline
  
  If GetGadgetState( #ListView_font_listfonts) <> -1 And  GetGadgetState( #ListView_font_style) <> -1
    style = 0
    For i = 0 To 4
      If GetGadgetItemState(#ListView_font_style,i) <> 0
        style + font_style(i)
      EndIf
    Next i
    If IsFont(#font_test)
      FreeFont(#font_test)
    EndIf
    font_charger = LoadFont(#font_test , GetGadgetText( #ListView_font_listfonts ) , GetGadgetState( #trackbar_font_taille) , style) 
    SetGadgetFont(#Text_font_test , FontID( #font_test ) )
    
    If IsImage(last_image)
      FreeImage( last_image )
    EndIf
    ; redessine bouton
    image = CreateImage( #PB_Any , largeur,hauteur,32,retour_couleur_fond_gadget)
    last_image = image
    StartDrawing( ImageOutput( image ) )
    DrawingMode(#PB_2DDrawing_Default)
    DrawingFont(font_charger)
    
    If centrage_largeur = 1
      centrage_x = 3
    ElseIf centrage_largeur = 2
      centrage_x = (largeur - TextWidth(text$)) / 2
    ElseIf centrage_largeur = 3
      centrage_x = largeur - TextWidth(text$) - 3
    EndIf
    If centrage_hauteur = 1
      centrage_y = 3
    ElseIf centrage_hauteur = 2
      centrage_y = (hauteur - TextHeight(text$)) / 2
    ElseIf centrage_hauteur = 3
      centrage_y = hauteur - TextHeight(text$) - 3
    EndIf

    DrawText(centrage_x, centrage_y, text$, retour_couleur_texte | $FF000000 , retour_couleur_fond_texte | $FF000000)
    StopDrawing()
    If IsGadget(numero_element)
      SetGadgetAttribute(numero_element, #PB_Button_Image , ImageID( image) )
    EndIf
    SetGadgetAttribute(#Text_font_test, #PB_Button_Image , ImageID( image) )
    
  EndIf
  retour_nom_font = GetGadgetText( #ListView_font_listfonts )
  retour_taille_font = GetGadgetState( #trackbar_font_taille)
  retour_style_font = style
EndProcedure

Procedure.b choix_fonts(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur, font_nom.s, font_taille, font_style )
  OpenWindow_Window_fonts()
  
  lf.LOGFONT
  lf\lfCharset = #DEFAULT_CHARSET
  hdc = GetDC_(WindowID(#Window_fonts))
  EnumFontFamiliesEx_(hdc,lf,@EnumFontFamExProc(),0,0)
  ReleaseDC_(WindowID(#Window_fonts),hdc)
  SortList( FaceName() , #PB_Sort_Ascending )
  last$ = ""
  ForEach FaceName()
    If FaceName() = last$
      DeleteElement( FaceName() )
    Else
      last$ = FaceName()
    EndIf
  Next
  ForEach FaceName()
    AddGadgetItem(#ListView_font_listfonts,-1 , FaceName() )
  Next
  
  If font_nom <> ""
    For i = 0 To CountGadgetItems(#ListView_font_listfonts)
      If GetGadgetItemText( #ListView_font_listfonts , i ) = font_nom
        SetGadgetState(#ListView_font_listfonts , i)
        Break
      EndIf
    Next i
  EndIf
  
  If font_taille <> 0
    SetGadgetState( #trackbar_font_taille , font_taille)
    SetGadgetText(#expli_font_taille , Str(font_taille))
  EndIf

  font_charger = LoadFont(#font_test , GetGadgetText( #ListView_font_listfonts ) , GetGadgetState( #trackbar_font_taille) , font_style) 
  SetGadgetFont(#Text_font_test , FontID( #font_test ) )

  If font_style <> 0 
    If Mod(font_style , #PB_Font_Italic) <> font_style
      SetGadgetItemState(#ListView_font_style , 1,1)
      font_style - #PB_Font_Italic
    EndIf
    If Mod(font_style , #PB_Font_Bold) <> font_style
      SetGadgetItemState(#ListView_font_style , 2,1)
      font_style - #PB_Font_Bold
    EndIf
    If Mod(font_style , #PB_Font_StrikeOut) <> font_style
      SetGadgetItemState(#ListView_font_style , 3,1)
      font_style - #PB_Font_StrikeOut
    EndIf
    If Mod(font_style , #PB_Font_Underline) <> font_style
      SetGadgetItemState(#ListView_font_style , 4,1)
      font_style - #PB_Font_Underline
    EndIf
  Else
    SetGadgetItemState(#ListView_font_style , 0,1)
  EndIf
  check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
  
  Repeat
    Event = WaitWindowEvent()
    Select Event
        ; ///////////////////
      Case #PB_Event_Gadget
        EventGadget = EventGadget()
        EventType = EventType()
        If EventGadget = #Text_font_1
        ElseIf EventGadget = #ListView_font_listfonts
          check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
        ElseIf EventGadget = #ListView_font_style
          check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
        ElseIf EventGadget = #trackbar_font_taille
          SetGadgetText( #expli_font_taille , Str(GetGadgetState( #trackbar_font_taille)) )
          check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
        ElseIf EventGadget = #Button_font_couleur_texte  
          resultat = ColorRequester()
          If resultat > -1
            retour_couleur_texte = resultat
            check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
          EndIf
        ElseIf EventGadget = #Button_font_couleur_fond_texte
          resultat = ColorRequester()
          If resultat > -1
            retour_couleur_fond_texte = resultat
            check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
          EndIf
        ElseIf EventGadget = #Button_font_couleur_gadget
          resultat = ColorRequester()
          If resultat > -1
            retour_couleur_fond_gadget = resultat
            check_fond_size(numero_element,image,text$, largeur, hauteur, centrage_largeur , centrage_hauteur )
          EndIf
        ElseIf EventGadget = #Button_font_ok
          CloseWindow(#Window_fonts)
          ProcedureReturn 1
        ElseIf EventGadget = #Button_font_cancel
          CloseWindow(#Window_fonts)
          ProcedureReturn
        EndIf
        ; ////////////////////////
      Case #PB_Event_CloseWindow
        EventWindow = EventWindow()
        If EventWindow = #Window_fonts
          CloseWindow(#Window_fonts)
          ProcedureReturn
        EndIf
    EndSelect
  ForEver
EndProcedure

 
;choix_fonts(#PB_Any , #PB_Any , "test 1234 @" , 400, 60, 400 , 100 , "MS Sans Serif",8 , 0)
; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; CursorPosition = 257
; Folding = w
; EnableThread
; EnableXP
; EnableCompileCount = 77
; EnableBuildCount = 0