﻿; max x / max y dernier gadget -> modifier pour scrollarea
; sur action -> nouvelle entree 
; icone exe (dans appli, exterieur)
; dessiner pourtour sur fenetre
; rajouter "lier a gadget list"
; image : haut bas gauche droite
; procedure panel pos_x pos_y (recursif possible)

;SetCurrentDirectory("g:\download\")

UseJPEGImageDecoder()
UseTGAImageDecoder()
UseTIFFImageDecoder()
UsePNGImageDecoder()

XIncludeFile("fonts.pb")

DataSection
  Image_checkbox:
    IncludeBinary ".\check.png"
  Image_panel:
    IncludeBinary ".\panel.png"
EndDataSection

; Windows
Enumeration
  #Window_de_dessin = 5
  #Window_gadgets
  #Window_propriete
  #Window_editor
  #fichier_config
  #menu_gadget
  #fichier_sauvegarde
EndEnumeration
; Gadgets
Enumeration
  #ScrollArea_principal = 10
  #ScrollArea_gadget
  #ScrollArea_propriete
  #font_tempo
  #font_par_defaut
  #image_normale
  #image_enfonce
  #Editor_editeur
  #button_copy_editor_to_clipboard
EndEnumeration
Enumeration
  #Button_Bouton = 900
  #Button_checkbox
  #Button_panel
EndEnumeration
; autre
Enumeration
  #image_contour = 1000
  #image_contour_copie
  #bouton_contour
  #Button_0  
EndEnumeration

#WM_LBUTTONDOWN = 513
#WM_LBUTTONUP    = 514

Declare rends_code()
; config
Global x_w_gadget = 0
Global y_w_gadget = 0
Global w_w_gadget = 355
Global h_w_gadget = 210
Global x_w_propriete = 0
Global y_w_propriete = 235
Global w_w_propriete = 355
Global h_w_propriete = 520
Global x_w_editor = 0
Global y_w_editor = 780
Global w_w_editor = 1150
Global h_w_editor = 235

Global old_pos_x
Global old_pos_y
Global old_largeur
Global old_hauteur
Global old_type$ = ""

; variables
Global curseur_souris = #IDC_ARROW
Global gauche_appuyer
Global x_moins , y_moins
Global deplacement_gadget
Global redimensionne_gadget
Global type.s
Global gadget_en_cours.l
Global police_par_defaut = LoadFont(#font_par_defaut , "MS Sans Serif",8)
Global centrage_texte
Global nom_de_sauvegarde$
Global dans_panel.l

Structure gadget_propriete
  nom_du_gadget.s
  numero_du_gadget.l
EndStructure

Global NewList gadget_propriete.gadget_propriete()

Global copie_clipboard$
Global numero_thread_clignotant.l
Global old_gadget
Global gadget_dessous
Global numero_panel.l
Global rajout_panel_x.l
Global rajout_panel_y.l

Structure sous
  nom.s
  valeur.s
EndStructure

Structure Gadget_2
  numero.l
  List sous.sous()
EndStructure
Global NewList Gadget_2.Gadget_2()

Structure image
  nom_image.s
  type.s
EndStructure
Global NewList image.image()

Global NewList propriete.s()
AddElement( propriete() )
propriete() = "bouton:nom txt txttransparent font xxx yyy long haut bouton_image _option_disable_invisible_multiligne_sansbord_option_ centrage_texte"
AddElement( propriete() )
propriete() = "window:nom txt xxx yyy long haut w_couleur_fond _windowlistcheckbox_systeme_bouton.minimise_bouton.maximise_redimensionne_barre.de.titre_outils_sans.bords_centrage.ecran_centrage.fenetre.mere_agrandit_reduit_pas.de.gadget_non.active _action_clic.gauche_clic.droit"
AddElement( propriete() )
propriete() = "checkbox:nom txt font xxx yyy long haut pre-cocher"
AddElement( propriete() )
propriete() = "panel:nom txt xxx yyy long haut"
Global Dim window_propriete(20)
window_propriete(0) = 1
window_propriete(1) = 1
window_propriete(2) = 1
window_propriete(3) = 1
window_propriete(4) = 1
window_propriete(7) = 1
Global Dim window_propriete_text.s(20)
window_propriete_text(0) = "SystemMenu"
window_propriete_text(1) = "MinimizeGadget"
window_propriete_text(2) = "MaximizeGadget"
window_propriete_text(3) = "SizeGadget"
window_propriete_text(4) = "TitleBar"
window_propriete_text(5) = "Tool"
window_propriete_text(6) = "BorderLess"
window_propriete_text(7) = "ScreenCentered"
window_propriete_text(8) = "WindowCentered"
window_propriete_text(9) = "Maximize"
window_propriete_text(10) = "Minimize"
window_propriete_text(11) = "NoGadgets"
window_propriete_text(12) = "NoActivate"
Global nombre_window_propriete

Global Dim window_action(20)

CreateImage(#image_contour , 50,25 )
StartDrawing(ImageOutput(#image_contour))
Box(0,0,50,25,RGB(255,0,0))
StopDrawing()

Declare.l lit_nombre_list_gadget_sous(txt$)
Declare.s lit_string_list_gadget_sous(txt$)

panel_ouvert = 0

Procedure lit_panel_xy(texte$)
  old_element = ListIndex( Gadget_2() )
  ForEach Gadget_2()
    If lit_string_list_gadget_sous("type") = "panel" And lit_string_list_gadget_sous("numero") = texte$
      rajout_panel_x = lit_nombre_list_gadget_sous("pos_x")
      rajout_panel_y = lit_nombre_list_gadget_sous("pos_y")
      SelectElement( Gadget_2() , old_element )
      ProcedureReturn 1
    EndIf 
  Next
  SelectElement( Gadget_2() , old_element )
  ProcedureReturn 0
EndProcedure

Procedure rajoute_a_list_gadget_sous(nom$ , txt$)
  ForEach gadget_2()\sous()
    If gadget_2()\sous()\nom = nom$
      gadget_2()\sous()\valeur = txt$
      ProcedureReturn
    EndIf
  Next
  AddElement( gadget_2()\sous() )
  gadget_2()\sous()\nom = nom$
  gadget_2()\sous()\valeur = txt$
EndProcedure

Procedure.l trouve_gadget_2(txt$, valeur$)
  index = ListIndex( Gadget_2() )
  ForEach Gadget_2()
    ForEach Gadget_2()\sous()
      If Gadget_2()\sous()\nom = txt$ And Gadget_2()\sous()\valeur = valeur$
        ProcedureReturn 1
      EndIf
    Next
  Next
  SelectElement( Gadget_2() , index)
  ProcedureReturn 0
EndProcedure

Procedure.l lit_nombre_list_gadget_sous(txt$)
  ForEach Gadget_2()\sous()
    If Gadget_2()\sous()\nom = txt$
      ProcedureReturn Val(Gadget_2()\sous()\valeur)
    EndIf
  Next
EndProcedure

Procedure.s lit_string_list_gadget_sous(txt$)
  ForEach Gadget_2()\sous()
    If Gadget_2()\sous()\nom = txt$
      ProcedureReturn Gadget_2()\sous()\valeur
    EndIf
  Next
EndProcedure

Procedure ecrit_fichier_config()
  If CreateFile(#fichier_config , "designer.cfg")
    WriteStringN(#fichier_config , Str(WindowX(#Window_gadgets) ))
    WriteStringN(#fichier_config , Str(WindowY(#Window_gadgets) ))
    WriteStringN(#fichier_config , Str(WindowWidth(#Window_gadgets) ))
    WriteStringN(#fichier_config , Str(WindowHeight(#Window_gadgets) ))
    WriteStringN(#fichier_config , Str(WindowX(#Window_propriete) ))
    WriteStringN(#fichier_config , Str(WindowY(#Window_propriete)))
    WriteStringN(#fichier_config , Str(WindowWidth(#Window_propriete)))
    WriteStringN(#fichier_config , Str(WindowHeight(#Window_propriete)))
    WriteStringN(#fichier_config , Str(WindowX(#Window_editor) ))
    WriteStringN(#fichier_config , Str(WindowY(#Window_editor) ))
    WriteStringN(#fichier_config , Str(WindowWidth(#Window_editor) ))
    WriteStringN(#fichier_config , Str(WindowHeight(#Window_editor) ))
    CloseFile(#fichier_config)
  EndIf    
EndProcedure

Procedure lit_fichier_config()
  If ReadFile(#fichier_config , "designer.cfg")
    x_w_gadget = Val(ReadString(#fichier_config))
    y_w_gadget = Val(ReadString(#fichier_config))
    w_w_gadget = Val(ReadString(#fichier_config))
    h_w_gadget = Val(ReadString(#fichier_config))
    x_w_propriete = Val(ReadString(#fichier_config))
    y_w_propriete = Val(ReadString(#fichier_config))
    w_w_propriete = Val(ReadString(#fichier_config))
    h_w_propriete = Val(ReadString(#fichier_config))
    x_w_editor = Val(ReadString(#fichier_config))
    y_w_editor = Val(ReadString(#fichier_config))
    w_w_editor = Val(ReadString(#fichier_config))
    h_w_editor = Val(ReadString(#fichier_config))
    CloseFile(#fichier_config)
  EndIf
EndProcedure

Procedure Callback(WindowID, message, wParam, lParam)
  Resultat = #PB_ProcessPureBasicEvents
  
  If GetDlgCtrlID_(wParam) = -1
    gadget_dessous = 0
    ProcedureReturn Resultat
  EndIf

  Select message
    Case #WM_SETCURSOR
      gadget_dessous = GetDlgCtrlID_(wParam)
      gadget_en_cours = gadget_dessous
  EndSelect
  ProcedureReturn Resultat
 EndProcedure

Procedure OpenWindow_Window_de_dessin()
  AddElement( gadget_2() )
  Gadget_2()\numero = OpenWindow(#Window_de_dessin, 450, 200, 675, 415, "Designer", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
  SmartWindowRefresh(#Window_de_dessin , #True)
  ImageGadget(#bouton_contour, 0, 0, 50, 25, 0 )
  HideGadget(#bouton_contour , 1)
  rajoute_a_list_gadget_sous("type" , "window" )
  rajoute_a_list_gadget_sous("numero" , Str(Gadget_2()\numero) )
  rajoute_a_list_gadget_sous("largeur" , "675" )
  rajoute_a_list_gadget_sous("hauteur" , "415" )
  rajoute_a_list_gadget_sous("txt_compile" , type )
  rajoute_a_list_gadget_sous("nom_compile" , "#window_" + Str(gadget_2()\numero) )
  rajoute_a_list_gadget_sous("pos_x" , Str(WindowX(#Window_de_dessin)) )
  rajoute_a_list_gadget_sous("pos_y" , Str(WindowY(#Window_de_dessin)) )
EndProcedure

Procedure OpenWindow_Window_gadgets()
  If OpenWindow(#Window_gadgets, x_w_gadget, y_w_gadget, w_w_gadget, h_w_gadget, "Choix gadgets", #PB_Window_SystemMenu|#PB_Window_TitleBar)
    If UseGadgetList(WindowID(#Window_gadgets))
      ScrollAreaGadget(#ScrollArea_gadget, 0, 0, 355, 210, 343, 410, 10, #PB_ScrollArea_Single)
        ButtonGadget(#Button_Bouton, 5, 5, 80, 25, "Bouton", #BS_FLAT)
        ButtonImageGadget(#Button_checkbox, 95, 5, 80, 25, ImageID(CatchImage(#PB_Any , ?Image_checkbox) ) )
        ButtonImageGadget(#Button_panel, 200, 5, 80, 25, ImageID(CatchImage(#PB_Any , ?Image_panel) ) )
      CloseGadgetList()
    EndIf
  EndIf
  If CreateMenu(#menu_gadget, WindowID(#Window_gadgets))
    MenuTitle("Fichier")
    MenuItem( 1, "Charger")
    MenuItem( 2, "Enregistrer")
    MenuItem( 3, "Enregistrer sous...")
  EndIf
EndProcedure

Procedure OpenWindow_Window_propriete()
  If OpenWindow(#Window_propriete, x_w_propriete, y_w_propriete, w_w_propriete, h_w_propriete, "Propriétés", #PB_Window_SystemMenu|#PB_Window_TitleBar)
    If UseGadgetList(WindowID(#Window_propriete))
      ScrollAreaGadget(#ScrollArea_propriete, 0, 0, 355, 515, 351, 511, 10, #PB_ScrollArea_Single)
      CloseGadgetList()
    EndIf
  EndIf
EndProcedure

Procedure OpenWindow_Window_editor()
  If OpenWindow(#Window_editor, x_w_editor, y_w_editor, w_w_editor, h_w_editor, "Visualisation du code", #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
    EditorGadget(#Editor_editeur, 0, 0, 1150, h_w_editor - 20)
  EndIf
EndProcedure

Procedure coche( txt$ , cocher.l)
  Protected old_element = ListIndex( gadget_propriete() )
  ForEach gadget_propriete()
    If gadget_propriete()\nom_du_gadget = txt$
      SetGadgetState( gadget_propriete()\numero_du_gadget , cocher )
    EndIf
  Next
  SelectElement( gadget_propriete(), old_element )
EndProcedure

Procedure change_texte(txt$, retour_nom_font$)
  Protected old_element = ListIndex( gadget_propriete() )
  ForEach gadget_propriete()
    If gadget_propriete()\nom_du_gadget = txt$ And Len(gadget_propriete()\nom_du_gadget) = Len(txt$)
      SetGadgetText( gadget_propriete()\numero_du_gadget , retour_nom_font$ )
      Break
    EndIf
  Next
  SelectElement( gadget_propriete(), old_element )
EndProcedure

Procedure ajoute_gadget_propriete(txt$)
  AddElement( gadget_propriete() )
  gadget_propriete()\nom_du_gadget = txt$
EndProcedure

Procedure.l ajoute_a_propiete(type$,x,y,largeur,hauteur,texte.s)
  If LCase(type$) = "textgadget"
    renvoi = TextGadget(#PB_Any , x, y, largeur, hauteur, texte)
  ElseIf LCase(type$) = "stringgadget"
    renvoi = StringGadget(#PB_Any , x, y, largeur, hauteur, texte)
  ElseIf LCase(type$) = "buttongadget"
    renvoi = ButtonGadget(#PB_Any , x, y, largeur, hauteur, texte)
  ElseIf LCase(type$) = "framegadget"
    renvoi = FrameGadget(#PB_Any , x, y, largeur, hauteur, texte)
  ElseIf LCase(type$) = "optiongadget"
    renvoi = OptionGadget(#PB_Any , x, y, largeur, hauteur, texte)
  ElseIf LCase(type$) = "checkboxgadget"
    renvoi = CheckBoxGadget(#PB_Any , x, y, largeur, hauteur, texte)
  ElseIf LCase(type$) = "listicongadget_check"
    renvoi = ListIconGadget(#PB_Any , x, y, largeur, hauteur, texte , 170 , #PB_ListIcon_CheckBoxes)
  EndIf
  ProcedureReturn renvoi
EndProcedure

Procedure creer_propriete(type$)
  Protected rajout_y = 0
  
  tmp$ = ""
  ForEach propriete()
    If StringField( propriete() , 1 , ":") = type$
      tmp$ = RemoveString( propriete() , type$ + ":")
      Break
    EndIf
  Next
  type$ = tmp$

  OpenGadgetList(#ScrollArea_propriete)
  
  ForEach gadget_propriete()
    FreeGadget( gadget_propriete()\numero_du_gadget )
  Next
  
  ClearList( gadget_propriete() )
  
  ; nom txt txttransparent font xxx yyy long haut
  istring = 0
  While StringField( type$ , istring+1 , " ") <> ""
    retour$ = StringField( type$ , istring+1 , " ")
    If retour$ = "nom"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget", 5 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "Nom du gadget :")
      ajoute_gadget_propriete("gadget_Nom_du_gadget")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("nom_compile") )
    EndIf
    If retour$ = "txt"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",5 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "Texte dans le gadget :")
      ajoute_gadget_propriete("gadget_Texte_dans_le_gadget")
      If lit_string_list_gadget_sous("txt_compile") = ""
        If lit_string_list_gadget_sous("type") = "bouton"
          gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("numero") )
        Else
          If lit_string_list_gadget_sous("txt_compile") = ""
            rajoute_a_list_gadget_sous("txt_compile" , GetWindowTitle( #Window_de_dessin ) )
            gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("txt_compile") )
          Else
            gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("txt_compile") )
          EndIf
        EndIf
      Else
        gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("txt_compile") )
      EndIf
    EndIf
    
    If retour$ = "txttransparent"
      ajoute_gadget_propriete("txt_transparent")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   5 ,  ((istring + b_string + rajout_y) * 20) + 2, 100 , 20 , "Texte transparent")
      If lit_nombre_list_gadget_sous("txt_transparent") = 1
        SetGadgetState( gadget_propriete()\numero_du_gadget , #PB_Checkbox_Checked)
      EndIf
    EndIf 
    
    If retour$ = "pre-cocher"
      ajoute_gadget_propriete("pre-cocher")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   5 ,  ((istring + b_string + rajout_y) * 20) + 2, 100 , 20 , "Pre cocher")
    EndIf
    If retour$ = "font"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",5 ,  ((istring + rajout_y) * 20) + 7, 100 , 20 , "Police du gadget :")
      ajoute_gadget_propriete("gadget_font")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("buttongadget",105 ,((istring + rajout_y) * 20) + 5, 25  , 20 , "...")
      
      ajoute_gadget_propriete("nom_font")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",190 ,((istring + rajout_y) * 20) + 8, 120 , 15 , lit_string_list_gadget_sous("font_nom") )    
    EndIf
    If retour$ = "w_couleur_fond"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",5 ,  ((istring + rajout_y) * 20) + 7, 100 , 20 , "couleur de fond :")
      ajoute_gadget_propriete("w_couleur_fond")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("buttongadget",105 ,((istring + rajout_y) * 20) + 5, 25  , 20 , "...")
      
      ajoute_gadget_propriete("nom_font")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",190 ,((istring + rajout_y) * 20) + 8, 120 , 15 , lit_string_list_gadget_sous("font_nom") )    
    EndIf
    If retour$ = "xxx"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",5 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "X :")
      ajoute_gadget_propriete("emplacement_x")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("pos_x") )
    EndIf
    If retour$ = "yyy"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",5 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "Y :")
      ajoute_gadget_propriete("emplacement_y")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("pos_y") )
    EndIf
    If retour$ = "long"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",5 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "Longueur :")
      ajoute_gadget_propriete("longueur_gadget")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("largeur") )
    EndIf
    If retour$ = "haut"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",5 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "Hauteur :")
      ajoute_gadget_propriete("hauteur_gadget")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("StringGadget", 190 ,((istring + rajout_y) * 20) + 5, 120 , 20 , lit_string_list_gadget_sous("hauteur") )
    EndIf

    If retour$ = "bouton_image"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("framegadget", 5 ,  ((istring + rajout_y) * 20) + 7, 300 , 110 , "Image :")
      rajout_y + 1
      ajoute_gadget_propriete("gadget_texte_image")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",100 ,((istring + rajout_y) * 20) + 8, 180 , 15 , GetFilePart(lit_string_list_gadget_sous("nom_image")) )
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",15 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "Image :")
      ajoute_gadget_propriete("gadget_image")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("buttongadget",65 ,((istring + rajout_y) * 20) + 5, 25  , 20 , "...")
      rajout_y + 1
      
      ajoute_gadget_propriete("gadget_texte_image_enfonce")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",100 ,((istring + rajout_y) * 20) + 8, 180 , 15 , GetFilePart(lit_string_list_gadget_sous("nom_image_enfonce")) )
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("textgadget",15 ,  ((istring + rajout_y) * 20) + 7, 175 , 20 , "Image 2 :")
      ajoute_gadget_propriete("gadget_image_enfonce")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("buttongadget",65 ,((istring + rajout_y) * 20) + 5, 25  , 20 , "...")
      rajout_y + 1
      ajoute_gadget_propriete("centrage_image")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   15 ,  ((istring + b_string + rajout_y) * 20) + 7, 100 , 20 , "centré")
      rajout_y + 1
      ajoute_gadget_propriete("plein_image")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   15 ,  ((istring + b_string + rajout_y) * 20) + 7, 100 , 20 , "plein")
      
      If lit_nombre_list_gadget_sous("image_centre") = 1
        coche("centrage_image" , #PB_Checkbox_Checked)
        coche("plein_image", #PB_Checkbox_Unchecked)
      EndIf
      If lit_nombre_list_gadget_sous("image_plein") = 1
        coche("plein_image", #PB_Checkbox_Checked)
        coche("centrage_image" , #PB_Checkbox_Unchecked)
      EndIf
      
    EndIf

    If retour$ = "centrage_texte"
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("framegadget", 5 ,  ((istring + rajout_y) * 20) + 7, 145 , 80 , "Centrage texte en largeur :")
      ajoute_gadget_propriete("gadget_centre_texte_largeur_gauche")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("optiongadget", 10 , ((istring + rajout_y) * 20) + 25 , 100 , 20 , "Gauche")
      ajoute_gadget_propriete("gadget_centre_texte_largeur_centre")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("optiongadget", 10 , ((istring + rajout_y) * 20) + 45 , 100 , 20 , "Centre")
      ajoute_gadget_propriete("gadget_centre_texte_largeur_droite")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("optiongadget", 10 , ((istring + rajout_y) * 20) + 65 , 100 , 20 , "Droite")
      If lit_nombre_list_gadget_sous("centrage_largeur") = 0 Or lit_nombre_list_gadget_sous("centrage_largeur") = 2 ; a verifier
        coche("gadget_centre_texte_largeur_centre" , 1)
        rajoute_a_list_gadget_sous("centrage_largeur" , "2" )
      ElseIf lit_nombre_list_gadget_sous("centrage_largeur") = 1
        coche("gadget_centre_texte_largeur_gauche" , 1)
        rajoute_a_list_gadget_sous("centrage_largeur" , "1" )
      Else
        coche("gadget_centre_texte_largeur_droite" , 1)
        rajoute_a_list_gadget_sous("centrage_largeur" , "0" )
      EndIf
      
      ajoute_gadget_propriete("rien")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("framegadget", 155 ,  ((istring + rajout_y) * 20) + 7, 145 , 80 , "Centrage texte en hauteur :")
      
      ajoute_gadget_propriete("gadget_centre_texte_hauteur_haut")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("optiongadget", 160 , ((istring + rajout_y) * 20) + 25 , 100 , 20 , "Haut")
      ajoute_gadget_propriete("gadget_centre_texte_hauteur_centre")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("optiongadget", 160 , ((istring + rajout_y) * 20) + 45 , 100 , 20 , "Centre")
      ajoute_gadget_propriete("gadget_centre_texte_hauteur_bas")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("optiongadget", 160 , ((istring + rajout_y) * 20) + 65 , 100 , 20 , "Bas")
      If lit_nombre_list_gadget_sous("centrage_hauteur") = 0 Or lit_nombre_list_gadget_sous("centrage_hauteur") = 2 ; a verifier
        coche( "gadget_centre_texte_hauteur_centre" , 1)
        rajoute_a_list_gadget_sous("centrage_hauteur" , "2" )
      ElseIf lit_nombre_list_gadget_sous("centrage_hauteur") = 1
        rajoute_a_list_gadget_sous("centrage_hauteur" , "1" )
        coche( "gadget_centre_texte_hauteur_haut" , 1)
      Else
        rajoute_a_list_gadget_sous("centrage_hauteur" , "0" )
        coche( "gadget_centre_texte_hauteur_bas" , 1)
      EndIf
      rajout_y + 3
    EndIf
    
    If Mid(retour$ , 1 , 8) = "_option_"
      retour$ = RemoveString( retour$ , "_option_")
      b_string = 1
      While StringField(retour$ , b_string , "_") <> ""
        retour_1$ = StringField(retour$ , b_string , "_")
        If retour_1$ = "disable"
          ajoute_gadget_propriete("gadget_inactif")
          gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   5 ,  ((istring + b_string + rajout_y) * 20) + 7, 100 , 20 , "Inactif")
        EndIf
        If retour_1$ = "invisible"
          ajoute_gadget_propriete("gadget_invisible")
          gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   5 ,  ((istring + b_string + rajout_y) * 20) + 7, 100 , 20 , "invisible")
        EndIf
        If retour_1$ = "multiligne"
          ajoute_gadget_propriete("gadget_multiligne")
          gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   5 ,  ((istring + b_string + rajout_y) * 20) + 7, 100 , 20 , "multiligne")
        EndIf
        If retour_1$ = "sansbord"
          ajoute_gadget_propriete("gadget_sansbord")
          gadget_propriete()\numero_du_gadget = ajoute_a_propiete("checkboxgadget",   5 ,  ((istring + b_string + rajout_y) * 20) + 7, 100 , 20 , "sans bord")
        EndIf
        
        b_string + 1
      Wend 
      rajout_y + b_string
    EndIf
    
    If Mid(retour$ , 1 , 20) = "_windowlistcheckbox_"
      ajoute_gadget_propriete("window_listbox_propriete")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("listicongadget_check",5 ,  ((istring + rajout_y) * 20) + 7, 175 , 120 , "proprietes :")
      retour$ = RemoveString( retour$ , "_windowlistcheckbox_")
      b_string = 1
      While StringField(retour$ , b_string , "_") <> ""
        AddGadgetItem( gadget_propriete()\numero_du_gadget , -1 , StringField(retour$ , b_string , "_"))
        b_string + 1
      Wend 
      ResizeGadget(gadget_propriete()\numero_du_gadget , #PB_Ignore , #PB_Ignore , #PB_Ignore , b_string * 18)
      rajout_y + b_string - 1
      For i_list = 0 To CountGadgetItems(gadget_propriete()\numero_du_gadget)
        If window_propriete(i_list) = 0
          SetGadgetItemState(gadget_propriete()\numero_du_gadget , i_list , 0)
        Else
          SetGadgetItemState(gadget_propriete()\numero_du_gadget , i_list , #PB_ListIcon_Checked )
        EndIf
      Next i_list
      nombre_window_propriete = i_list - 1
    EndIf
    
    If Mid(retour$ , 1 , 8) = "_action_"
      ajoute_gadget_propriete("windows_listbox_action")
      gadget_propriete()\numero_du_gadget = ajoute_a_propiete("listicongadget_check",5 ,  ((istring + rajout_y) * 20), 175 , 120 , "Actions :")
      retour$ = RemoveString( retour$ , "_action_")
      b_string = 1
      While StringField(retour$ , b_string , "_") <> ""
        AddGadgetItem( gadget_propriete()\numero_du_gadget , -1 , StringField(retour$ , b_string , "_"))
        b_string + 1
      Wend 
      ResizeGadget(gadget_propriete()\numero_du_gadget , #PB_Ignore , #PB_Ignore , #PB_Ignore , (b_string * 18) + 10)
      rajout_y + b_string - 1
      For i_list = 0 To CountGadgetItems(gadget_propriete()\numero_du_gadget)
        If window_action(i_list) = 0
          SetGadgetItemState(gadget_propriete()\numero_du_gadget , i_list , 0)
        Else
          SetGadgetItemState(gadget_propriete()\numero_du_gadget , i_list , #PB_ListIcon_Checked )
        EndIf
      Next i_list
    EndIf
      
    istring + 1
  Wend  
  
  CloseGadgetList()
  rends_code()

EndProcedure

Procedure redessine_image_bouton()
  If IsImage(#image_normale)
    FreeImage( #image_normale )
  EndIf
  CreateImage( #image_normale , lit_nombre_list_gadget_sous("largeur") , lit_nombre_list_gadget_sous("hauteur") , 32, lit_nombre_list_gadget_sous("couleur_fond_gadget") )
  
  If IsFont(#font_tempo)
    FreeFont(#font_tempo)
  EndIf
  LoadFont(#font_tempo , lit_string_list_gadget_sous("font_nom") , lit_nombre_list_gadget_sous("font_taille") , lit_nombre_list_gadget_sous("font_style") ) 
  
  StartDrawing( ImageOutput( #image_normale ) )
  
  If lit_string_list_gadget_sous("nom_image") <> ""
    tmp_img = LoadImage( #PB_Any , lit_string_list_gadget_sous("nom_image") )
    rajoute_a_list_gadget_sous("image_x" , "0")
    rajoute_a_list_gadget_sous("image_y" , "0")
    If lit_nombre_list_gadget_sous("image_centre") = 1 And (lit_nombre_list_gadget_sous("largeur") > ImageWidth(tmp_img) Or lit_nombre_list_gadget_sous("hauteur") > ImageHeight(tmp_img))
      DrawImage(ImageID(tmp_img) , (lit_nombre_list_gadget_sous("largeur") / 2) - (ImageWidth(tmp_img) / 2) , (lit_nombre_list_gadget_sous("hauteur") / 2) - (ImageHeight(tmp_img) / 2) )
      rajoute_a_list_gadget_sous("image_x" , Str((lit_nombre_list_gadget_sous("largeur") / 2) - (ImageWidth(tmp_img) / 2)) )
      rajoute_a_list_gadget_sous("image_y" , Str((lit_nombre_list_gadget_sous("hauteur") / 2) - (ImageHeight(tmp_img) / 2)) )
    ElseIf lit_nombre_list_gadget_sous("image_plein") = 1
      DrawImage(ImageID(tmp_img) , lit_nombre_list_gadget_sous("image_x") , lit_nombre_list_gadget_sous("image_y")  , lit_nombre_list_gadget_sous("largeur") , lit_nombre_list_gadget_sous("hauteur") )
    Else
      DrawImage(ImageID(tmp_img) , lit_nombre_list_gadget_sous("image_x") , lit_nombre_list_gadget_sous("image_y") )
    EndIf
    
  EndIf
  
  DrawingFont( FontID(#font_tempo) )
  DrawingMode(#PB_2DDrawing_Default)
  
  If lit_nombre_list_gadget_sous("txt_transparent") = 1
    DrawingMode(#PB_2DDrawing_Default | #PB_2DDrawing_Transparent )
  EndIf
  
  If lit_nombre_list_gadget_sous("centrage_largeur") = 1
    centrage_x = 3
  ElseIf lit_nombre_list_gadget_sous("centrage_largeur") = 2
    centrage_x = (lit_nombre_list_gadget_sous("largeur") - TextWidth(lit_string_list_gadget_sous("txt_compile") )) / 2
  ElseIf lit_nombre_list_gadget_sous("centrage_largeur") = 3
    centrage_x = lit_nombre_list_gadget_sous("largeur") - TextWidth(lit_string_list_gadget_sous("txt_compile") ) - 3
  EndIf
  If lit_nombre_list_gadget_sous("centrage_hauteur") = 1
    centrage_y = 3
  ElseIf lit_nombre_list_gadget_sous("centrage_hauteur") = 2
    centrage_y = (lit_nombre_list_gadget_sous("hauteur") - TextHeight(lit_string_list_gadget_sous("txt_compile") )) / 2
  ElseIf lit_nombre_list_gadget_sous("centrage_hauteur") = 3
    centrage_y = lit_nombre_list_gadget_sous("hauteur") - TextHeight(lit_string_list_gadget_sous("txt_compile") ) - 3
  EndIf
  
  DrawText(centrage_x , centrage_y, lit_string_list_gadget_sous("txt_compile"), lit_nombre_list_gadget_sous("couleur_texte") | $FF000000 , lit_nombre_list_gadget_sous("couleur_fond_texte") | $FF000000)
  StopDrawing()
  
  SetGadgetAttribute(lit_nombre_list_gadget_sous("numero") ,#PB_Button_Image,ImageID( #image_normale ) )

EndProcedure

Procedure entoure_gadget(tour = 1)
  Protected rajoute_a_x = 0
  Protected rajoute_a_y = 0
  
  If dans_panel = 1
    If lit_panel_xy( lit_string_list_gadget_sous("panel") ) = 1
      rajoute_a_x = rajout_panel_x
      rajoute_a_y = rajout_panel_y
    EndIf 
  EndIf
  
  StartDrawing( WindowOutput(#Window_de_dessin) )
  If old_largeur <> 0 And old_hauteur <> 0
    For x = 1 To 4
      ; dessus
      Line(old_pos_x - x,old_pos_y - x,old_largeur + (x * 2) , 1 , GetSysColor_(#COLOR_BTNFACE) )
      ; dessous
      Line(old_pos_x - x,old_pos_y + old_hauteur + x,old_largeur + (x * 2) , 1 , GetSysColor_(#COLOR_BTNFACE) )
      ; gauche
      Line(old_pos_x - x,old_pos_y - x, 1 , old_hauteur + (x * 2) , GetSysColor_(#COLOR_BTNFACE) )
      ; droite
      Line(old_pos_x + old_largeur + x,old_pos_y - x, 1 , old_hauteur + (x * 2) , GetSysColor_(#COLOR_BTNFACE) )
    Next
  EndIf

  If tour = 1
    For x = 1 To 4
      ; dessus
      Line(lit_nombre_list_gadget_sous("pos_x") - x + rajoute_a_x,lit_nombre_list_gadget_sous("pos_y") - x + rajoute_a_y,lit_nombre_list_gadget_sous("largeur") + (x * 2) , 1 , RGB(255,0,0) )
      ; dessous
      Line(lit_nombre_list_gadget_sous("pos_x") - x + rajoute_a_x,lit_nombre_list_gadget_sous("pos_y") + lit_nombre_list_gadget_sous("hauteur") + x + rajoute_a_y,lit_nombre_list_gadget_sous("largeur") + (x * 2) , 1 , RGB(255,0,0) )
      ; gauche
      Line(lit_nombre_list_gadget_sous("pos_x") - x + rajoute_a_x,lit_nombre_list_gadget_sous("pos_y") - x + rajoute_a_y, 1 , lit_nombre_list_gadget_sous("hauteur") + (x * 2) , RGB(255,0,0) )
      ; droite
      Line(lit_nombre_list_gadget_sous("pos_x") + lit_nombre_list_gadget_sous("largeur") + x + rajoute_a_x,lit_nombre_list_gadget_sous("pos_y") - x + rajoute_a_y, 1 , lit_nombre_list_gadget_sous("hauteur") + (x * 2) , RGB(255,0,0) )
    Next
    old_pos_x =   lit_nombre_list_gadget_sous("pos_x") + rajoute_a_x
    old_pos_y =   lit_nombre_list_gadget_sous("pos_y") + rajoute_a_y
    old_largeur = lit_nombre_list_gadget_sous("largeur")
    old_hauteur = lit_nombre_list_gadget_sous("hauteur")
  ElseIf tour = 0
    old_pos_x =   0
    old_pos_y =   0
    old_largeur = 0
    old_hauteur = 0
  EndIf
  StopDrawing() 
  old_type$ = lit_string_list_gadget_sous("type")
EndProcedure

Procedure kill_thread(valeur)
  If IsThread(valeur)
    If old_gadget <> 0
      gardien = ListIndex( Gadget_2() )
      SelectElement( gadget_2() , old_gadget )
      If IsImage(#image_normale)
        SetGadgetAttribute(lit_nombre_list_gadget_sous("numero"),#PB_Button_Image,ImageID( #image_normale) )
      EndIf
      SelectElement( Gadget_2() , gardien )
    EndIf
    KillThread(valeur)
    While IsThread(valeur)
      Delay(5)
    Wend
  EndIf
EndProcedure

Procedure ajoute_a_editor_et_clipboard(txt$)
  AddGadgetItem( #Editor_editeur , -1 , txt$)
  copie_clipboard$ + txt$ + Chr(13) + Chr(10)
EndProcedure

Procedure.s rajoute_un_flag(ancien_texte$,txt$)
  If ancien_texte$ <> ","
    ancien_texte$ + "|" + txt$
  Else
    ProcedureReturn txt$
  EndIf
  ProcedureReturn ancien_texte$
EndProcedure

Procedure rends_code()
  Protected NewList Enumerations_window.s()
  Protected NewList Enumerations_gadget.s()
  Protected NewList Enumerations_fonts.s()
  Protected NewList parametres_globaux.s()
  Protected NewList parametres_images.s()
  Protected NewList code_fenetre.s()
  Protected NewList code_procedure.s()
  Protected NewList code_image_bouton.s()
  Structure code_datasection
    code_datasection.s
    numero.s
    ligne.s
  EndStructure
  
  Protected NewList code_datasection.code_datasection()
  
  Protected Dim utilise.l(100)
  Protected Dim utilise_txt.s(100)
  utilise_txt(0) = "UseJPEGImageDecoder()"
  utilise_txt(1) = "UsePNGImageDecoder()"
  utilise_txt(2) = "UseTGAImageDecoder()"
  utilise_txt(3) = "UseTIFFImageDecoder()"
  
  Protected rajouter_procedure_sans_bord_bouton = 0
  Protected rajouter_procedure_sans_bord_bouton_image = 0
  Protected rajoute_proc_image.b = 0
  
  old_element = ListIndex( Gadget_2() )
  
  ForEach gadget_2()
    If lit_string_list_gadget_sous("type") = "window"
    ;{
      AddElement( Enumerations_window() )
      Enumerations_window() = lit_string_list_gadget_sous("nom_compile")
      AddElement( code_fenetre() )
      
      compteur_i_list = 0
      Protected texte_fenetre_options.s = ""
      For i_list = 0 To nombre_window_propriete
        If window_propriete(i_list) = 1
          If compteur_i_list <> 0
            texte_fenetre_options + "|"
          EndIf
          texte_fenetre_options + "#PB_Window_" + window_propriete_text(i_list)
          compteur_i_list + 1
        EndIf
      Next i_list
      code_fenetre() = "OpenWindow(" + lit_string_list_gadget_sous("nom_compile") + "," + lit_string_list_gadget_sous("pos_x") + "," + lit_string_list_gadget_sous("pos_y") + "," + lit_string_list_gadget_sous("largeur") + "," + lit_string_list_gadget_sous("hauteur") + "," + Chr(34) + lit_string_list_gadget_sous("txt_compile") + Chr(34) + "," + texte_fenetre_options + ")"
      If Val(lit_string_list_gadget_sous("w_couleur_fond")) <> 0
        AddElement( code_fenetre() )
        code_fenetre() = "SetWindowColor(" + lit_string_list_gadget_sous("nom_compile") + "," + lit_string_list_gadget_sous("w_couleur_fond") + ")"
      EndIf 
      ;}
    ElseIf lit_string_list_gadget_sous("type") = "bouton"
    ;{  
      AddElement( Enumerations_gadget() )
      Enumerations_gadget() = lit_string_list_gadget_sous("nom_compile")
      ; bouton classique
      If lit_nombre_list_gadget_sous("centrage_hauteur") = 2 And lit_nombre_list_gadget_sous("couleur_texte") = 0 And lit_nombre_list_gadget_sous("couleur_fond_texte") = GetSysColor_(#COLOR_BTNFACE) And lit_nombre_list_gadget_sous("couleur_fond_gadget") = GetSysColor_(#COLOR_BTNFACE) And lit_string_list_gadget_sous("nom_image") = ""
        AddElement( code_fenetre() )
        ; rajouter centrage largeur
        flag$ = ","
        If lit_nombre_list_gadget_sous("centrage_largeur") = 1
          flag$ + rajoute_un_flag( flag$ , "#PB_Button_Left")
        ElseIf lit_nombre_list_gadget_sous("centrage_largeur") = 3
          flag$ + rajoute_un_flag( flag$ , "#PB_Button_Right")
        EndIf
        If flag$ = ","
          flag$ = ""
        EndIf
        If lit_nombre_list_gadget_sous("sans_bord") = 0
          code_fenetre() = "ButtonGadget(" + lit_string_list_gadget_sous("nom_compile") + "," + lit_string_list_gadget_sous("pos_x") + "," + lit_string_list_gadget_sous("pos_y") + "," + lit_string_list_gadget_sous("largeur") + "," + lit_string_list_gadget_sous("hauteur") + "," + Chr(34) + lit_string_list_gadget_sous("txt_compile") + Chr(34) + flag$ + ")"
        Else
          rajouter_procedure_sans_bord_bouton = 1
          code_fenetre() = "ButtonGadgetAlpha_(" + lit_string_list_gadget_sous("nom_compile") + "," + lit_string_list_gadget_sous("pos_x") + "," + lit_string_list_gadget_sous("pos_y") + "," + lit_string_list_gadget_sous("largeur") + "," + lit_string_list_gadget_sous("hauteur") + "," + Chr(34) + lit_string_list_gadget_sous("txt_compile") + Chr(34) + flag$ + ")"
        EndIf
        ; si font
        If lit_string_list_gadget_sous("font_nom") <> "MS Sans Serif" Or lit_nombre_list_gadget_sous("font_style") <> 0 Or lit_nombre_list_gadget_sous("font_taille") <> 8
          AddElement( code_fenetre() )
          code_fenetre() = "SetGadgetFont(" + lit_string_list_gadget_sous("nom_compile") + ", FontID(LoadFont(#PB_Any, " + Chr(34) + lit_string_list_gadget_sous("font_nom") + Chr(34) + " , " + lit_string_list_gadget_sous("font_taille") + " , " + lit_string_list_gadget_sous("font_style") + ")))"
        EndIf
        ; bouton necessitant un dessin  
      Else
        AddElement( code_fenetre() )
        If lit_nombre_list_gadget_sous("sans_bord") = 0
          AddElement( code_fenetre() )
          code_fenetre() = "ButtonImageGadget(" + lit_string_list_gadget_sous("nom_compile") + "," + lit_string_list_gadget_sous("pos_x") + "," + lit_string_list_gadget_sous("pos_y") + "," + lit_string_list_gadget_sous("largeur") + "," + lit_string_list_gadget_sous("hauteur") + ",ImageID(" + lit_string_list_gadget_sous("nom_compile") + "_image) )" 
          If lit_string_list_gadget_sous("nom_image_enfonce") <> ""
            AddElement( code_fenetre() )
            code_fenetre() = "SetGadgetAttribute(" + lit_string_list_gadget_sous("nom_compile") + ", #PB_Button_PressedImage , ImageID(" + lit_string_list_gadget_sous("nom_compile") + "_image_enfonce) )" 
          EndIf
        Else
          rajouter_procedure_sans_bord_bouton_image = 1
          code_fenetre() = "ButtonImageGadgetAlpha_(" + lit_string_list_gadget_sous("nom_compile") + "," + lit_string_list_gadget_sous("pos_x") + "," + lit_string_list_gadget_sous("pos_y") + "," + lit_string_list_gadget_sous("largeur") + "," + lit_string_list_gadget_sous("hauteur") + "," + lit_string_list_gadget_sous("nom_compile") + "_image )" 
        EndIf
        AddElement( Enumerations_gadget() )
        Enumerations_gadget() = lit_string_list_gadget_sous("nom_compile") + "_image"
        rajoute_proc_image = 1
        ;;;;;;;
        AddElement( code_image_bouton() )
        code_image_bouton() = "image_bouton(" + lit_string_list_gadget_sous("nom_compile") + "_image" + " , ?data_" + RemoveString(lit_string_list_gadget_sous("nom_compile") , "#") + " , " + lit_string_list_gadget_sous("largeur") + " , " + lit_string_list_gadget_sous("hauteur") + " , " + lit_string_list_gadget_sous("couleur_fond_gadget") + " , " + Chr(34) + lit_string_list_gadget_sous("font_nom") + Chr(34) + " , " + lit_string_list_gadget_sous("font_taille") + " , " + lit_string_list_gadget_sous("font_style") + " , " + Str(lit_nombre_list_gadget_sous("image_plein")) + " , " + lit_string_list_gadget_sous("image_x") + " , " + lit_string_list_gadget_sous("image_y") + " , " + Str(lit_nombre_list_gadget_sous("txt_transparent")) + " , " + lit_nombre_list_gadget_sous("centrage_largeur") + " , " + lit_nombre_list_gadget_sous("centrage_hauteur") + " , " + Chr(34) + lit_string_list_gadget_sous("txt_compile") + Chr(34) + " , " + Str(lit_nombre_list_gadget_sous("couleur_texte")) + " , " + Str(lit_nombre_list_gadget_sous("couleur_fond_texte")) + ")"
        If lit_string_list_gadget_sous("nom_image_enfonce") <> ""
          AddElement( Enumerations_gadget() )
          Enumerations_gadget() = lit_string_list_gadget_sous("nom_compile") + "_image_enfonce"
          AddElement( code_image_bouton() )
          code_image_bouton() = "image_bouton(" + lit_string_list_gadget_sous("nom_compile") + "_image_enfonce" + " , ?data_" + RemoveString(lit_string_list_gadget_sous("nom_compile") , "#") + "_enfonce , " + lit_string_list_gadget_sous("largeur") + " , " + lit_string_list_gadget_sous("hauteur") + " , " + lit_string_list_gadget_sous("couleur_fond_gadget") + " , " + Chr(34) + lit_string_list_gadget_sous("font_nom") + Chr(34) + " , " + lit_string_list_gadget_sous("font_taille") + " , " + lit_string_list_gadget_sous("font_style") + " , " + Str(lit_nombre_list_gadget_sous("image_plein")) + " , " + lit_string_list_gadget_sous("image_x") + " , " + lit_string_list_gadget_sous("image_y") + " , " + Str(lit_nombre_list_gadget_sous("txt_transparent")) + " , " + lit_nombre_list_gadget_sous("centrage_largeur") + " , " + lit_nombre_list_gadget_sous("centrage_hauteur") + " , " + Chr(34) + lit_string_list_gadget_sous("txt_compile") + Chr(34) + " , " + Str(lit_nombre_list_gadget_sous("couleur_texte")) + " , " + Str(lit_nombre_list_gadget_sous("couleur_fond_texte")) + ")"
        EndIf
         
        If lit_string_list_gadget_sous("nom_image") <> ""
          If lit_string_list_gadget_sous("type_image") = "jpg"
            utilise(0) = 1
          ElseIf lit_string_list_gadget_sous("type_image") = "png"
            utilise(1) = 1
          ElseIf lit_string_list_gadget_sous("type_image") = "tga"
            utilise(2) = 1
          ElseIf lit_string_list_gadget_sous("type_image") = "tiff"
            utilise(3) = 1
          EndIf
          AddElement( code_datasection() )
          code_datasection()\numero = "Data_" + RemoveString(lit_string_list_gadget_sous("nom_compile"),"#") + ":"
          code_datasection()\ligne = lit_string_list_gadget_sous("nom_image")
        EndIf
        
        If lit_string_list_gadget_sous("nom_image_enfonce") <> ""
          If lit_string_list_gadget_sous("type_image") = "jpg"
            utilise(0) = 1
          ElseIf lit_string_list_gadget_sous("type_image") = "png"
            utilise(1) = 1
          ElseIf lit_string_list_gadget_sous("type_image") = "tga"
            utilise(2) = 1
          ElseIf lit_string_list_gadget_sous("type_image") = "tiff"
            utilise(3) = 1
          EndIf
          AddElement( code_datasection() )
          code_datasection()\numero = "Data_" + RemoveString(lit_string_list_gadget_sous("nom_compile"),"#") + "_enfonce:"
          code_datasection()\ligne = lit_string_list_gadget_sous("nom_image_enfonce")
        EndIf
        
      EndIf
      ;}
    ElseIf lit_string_list_gadget_sous("type") = "checkbox"
    ;{
      AddElement( Enumerations_gadget() )
      Enumerations_gadget() = lit_string_list_gadget_sous("nom_compile")
      AddElement( code_fenetre() )
      code_fenetre() = "CheckboxGadget(" + lit_string_list_gadget_sous("nom_compile") + "," + lit_string_list_gadget_sous("pos_x") + "," + lit_string_list_gadget_sous("pos_y") + "," + lit_string_list_gadget_sous("largeur") + "," + lit_string_list_gadget_sous("hauteur") + "," + Chr(34) + lit_string_list_gadget_sous("txt_compile") + Chr(34) + ")"
      If lit_string_list_gadget_sous("font_nom") <> "MS Sans Serif" Or lit_nombre_list_gadget_sous("font_style") <> 0 Or lit_nombre_list_gadget_sous("font_taille") <> 8
        AddElement( code_fenetre() )
        code_fenetre() = "SetGadgetFont(" + lit_string_list_gadget_sous("nom_compile") + ", FontID(LoadFont(#PB_Any, " + Chr(34) + lit_string_list_gadget_sous("font_nom") + Chr(34) + " , " + lit_string_list_gadget_sous("font_taille") + " , " + lit_string_list_gadget_sous("font_style") + ")))"
      EndIf
      If Val(lit_string_list_gadget_sous("pre-cocher")) = 1
        AddElement( code_fenetre() )
        code_fenetre() = "SetGadgetState(" + lit_string_list_gadget_sous("nom_compile") + ", #PB_CheckBox_Checked)"
      EndIf
    ;}  
        
      
    EndIf
    
    If lit_nombre_list_gadget_sous("disable") = 1
      AddElement( code_fenetre() )
      code_fenetre() = "DisableGadget(" + lit_string_list_gadget_sous("nom_compile") + ",1)"
    EndIf
    If lit_nombre_list_gadget_sous("invisible") = 1
      AddElement( code_fenetre() )
      code_fenetre() = "HideGadget(" + lit_string_list_gadget_sous("nom_compile") + ",1)"
    EndIf
  Next
  
  ClearClipboard()
  copie_clipboard$ = ""
  ClearGadgetItems( #Editor_editeur )
  
  ; generique
  ajoute_a_editor_et_clipboard( "; generique")
  ajoute_a_editor_et_clipboard( "Enumeration")
  ajoute_a_editor_et_clipboard( "  #font_tempo")
  ajoute_a_editor_et_clipboard( "EndEnumeration")
  ajoute_a_editor_et_clipboard( "")
  
  ; enumeration
  ajoute_a_editor_et_clipboard( "; Fenetres")
  ajoute_a_editor_et_clipboard( "Enumeration")
  ForEach( Enumerations_window() )
    ajoute_a_editor_et_clipboard( "  " + Enumerations_window())
  Next
  ajoute_a_editor_et_clipboard( "EndEnumeration")
  ajoute_a_editor_et_clipboard( "")
  
  If ListSize( Enumerations_gadget() )
    ajoute_a_editor_et_clipboard( "; Gadgets")
    ajoute_a_editor_et_clipboard( "Enumeration")
    ForEach( Enumerations_gadget() )
      ajoute_a_editor_et_clipboard( "  " + Enumerations_gadget())
    Next
    ajoute_a_editor_et_clipboard( "EndEnumeration")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  If ListSize( Enumerations_fonts() )
    ajoute_a_editor_et_clipboard( "; Fonts")
    ajoute_a_editor_et_clipboard( "Enumeration")
    ForEach( Enumerations_fonts() )
      ajoute_a_editor_et_clipboard( "  " + Enumerations_fonts())
    Next
    ajoute_a_editor_et_clipboard( "EndEnumeration")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  If ListSize( parametres_images() )
    ajoute_a_editor_et_clipboard( "; Fonts")
    ajoute_a_editor_et_clipboard( "Enumeration")
    ForEach( parametres_images() )
      ajoute_a_editor_et_clipboard( "  " + parametres_images())
    Next
    ajoute_a_editor_et_clipboard( "EndEnumeration")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  ;utilisation supplementaire
  i = 0
  j = 0
  While utilise_txt(i) <> ""
    If utilise(i) = 1
      ajoute_a_editor_et_clipboard(utilise_txt(i))
      j + 1
    EndIf
    i + 1
  Wend
  If j > 0
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  ; data section
  If ListSize( code_datasection() ) > 0
    ajoute_a_editor_et_clipboard( "DataSection" )
    ForEach code_datasection()
      ajoute_a_editor_et_clipboard( code_datasection()\numero )
      ajoute_a_editor_et_clipboard( "  IncludeBinary " + Chr(34) + code_datasection()\ligne + Chr(34) )
    Next
    ajoute_a_editor_et_clipboard( "EndDataSection" )
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  
  ; declaration
  une_declaration = 0
  If window_action(0) = 1
    ajoute_a_editor_et_clipboard( "Declare window_clic_gauche(WindowsId)")
    une_declaration + 1
  EndIf
  If window_action(1) = 1
    ajoute_a_editor_et_clipboard( "Declare window_clic_droit(WindowsId)")
    une_declaration + 1
  EndIf
  If une_declaration > 0
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  
  ; procedure bouton_sans_bord_bouton
  If rajouter_procedure_sans_bord_bouton = 1
    ajoute_a_editor_et_clipboard( "Procedure ButtonGadgetAlpha_(gadget,x,y,w,h,txt.s)")
    ajoute_a_editor_et_clipboard( "  ContainerGadget(#PB_Any,x,y,w,h)")
    ajoute_a_editor_et_clipboard( "  ButtonGadget(gadget, -4, -4, w+8, h+8, txt)")
    ajoute_a_editor_et_clipboard( "  CloseGadgetList()")
    ajoute_a_editor_et_clipboard( "EndProcedure")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  ; procedure bouton_sans_bord_bouton_image
  If rajouter_procedure_sans_bord_bouton_image = 1
    ajoute_a_editor_et_clipboard( "Procedure ButtonImageGadgetAlpha_(gadget,x,y,w,h,image_id)")
    ajoute_a_editor_et_clipboard( "  ContainerGadget(#PB_Any,x,y,w,h)")
    ajoute_a_editor_et_clipboard( "  ButtonImageGadget(gadget, -4, -4, w+8, h+8, imageid(image_id) )")
    ajoute_a_editor_et_clipboard( "  CloseGadgetList()")
    ajoute_a_editor_et_clipboard( "EndProcedure")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  ; procedure window clic gauche
  If window_action(0) = 1
    ajoute_a_editor_et_clipboard( "Procedure window_clic_gauche(WindowsId)")
    ajoute_a_editor_et_clipboard( "  Debug " + Chr(34) + "Clic gauche" + Chr(34) )
    ajoute_a_editor_et_clipboard( "EndProcedure")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  ; procedure window click droit
  If window_action(1) = 1
    ajoute_a_editor_et_clipboard( "Procedure window_clic_droit(WindowsId)")
    ajoute_a_editor_et_clipboard( "  Debug " + Chr(34) + "Clic droit" + Chr(34) )
    ajoute_a_editor_et_clipboard( "EndProcedure")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  ; procedure image
  If rajoute_proc_image = 1
    ajoute_a_editor_et_clipboard( "; procedure image_bouton")
    ajoute_a_editor_et_clipboard( "Procedure image_bouton(numero_gadget , adresse_gadget , largeur , hauteur , couleur_fond_gadget, font_nom.s , font_taille , font_style , image_plein , image_x , image_y , txt_transparent , centrage_largeur , centrage_hauteur , txt_compile.s , couleur_texte , couleur_fond_texte)")
    ajoute_a_editor_et_clipboard( "  CreateImage( numero_gadget , largeur , hauteur , 32, RGB(Red(couleur_fond_gadget) , Green(couleur_fond_gadget) , Blue(couleur_fond_gadget) ) )" )
    ajoute_a_editor_et_clipboard( "  tmp_image = CatchImage(#PB_Any, adresse_gadget)" )
    ajoute_a_editor_et_clipboard( "  LoadFont(#font_tempo , font_nom , font_taille , font_style )" )
    ajoute_a_editor_et_clipboard( "  StartDrawing( ImageOutput( numero_gadget ) )" )
    ajoute_a_editor_et_clipboard( "  if image_plein = 0" )
    ajoute_a_editor_et_clipboard( "    DrawImage(ImageID(tmp_image) , image_x , image_y )" )
    ajoute_a_editor_et_clipboard( "  else" )
    ajoute_a_editor_et_clipboard( "    DrawImage(ImageID(tmp_image) , image_x , image_y , largeur , hauteur )" )
    ajoute_a_editor_et_clipboard( "  endif")
    ajoute_a_editor_et_clipboard( "  DrawingFont( FontID(#font_tempo) )" )
    ajoute_a_editor_et_clipboard( "  If txt_transparent = 0 " )
    ajoute_a_editor_et_clipboard( "    DrawingMode(#PB_2DDrawing_Default)" )
    ajoute_a_editor_et_clipboard( "  Else")
    ajoute_a_editor_et_clipboard( "    DrawingMode(#PB_2DDrawing_Transparent)" )
    ajoute_a_editor_et_clipboard( "  endif")
    ajoute_a_editor_et_clipboard( "  If centrage_largeur = 1" )
    ajoute_a_editor_et_clipboard( "    centrage_x = 1" )
    ajoute_a_editor_et_clipboard( "  ElseIf centrage_largeur = 2" )
    ajoute_a_editor_et_clipboard( "    centrage_x = ( largeur - TextWidth(txt_compile) ) / 2" )
    ajoute_a_editor_et_clipboard( "  Else" )
    ajoute_a_editor_et_clipboard( "    centrage_x = ( largeur - TextWidth(txt_compile) ) -3" )
    ajoute_a_editor_et_clipboard( "  endif")
    ajoute_a_editor_et_clipboard( "  If centrage_hauteur = 1" )
    ajoute_a_editor_et_clipboard( "    centrage_y = 1" )
    ajoute_a_editor_et_clipboard( "  ElseIf centrage_hauteur = 2" )
    ajoute_a_editor_et_clipboard( "    centrage_y = ( hauteur - TextWidth(txt_compile) ) / 2" )
    ajoute_a_editor_et_clipboard( "  Else" )
    ajoute_a_editor_et_clipboard( "    centrage_y = ( hauteur - TextWidth(txt_compile) ) -3" )
    ajoute_a_editor_et_clipboard( "  endif")
    ajoute_a_editor_et_clipboard( "  If couleur_texte <> 0" )
    ajoute_a_editor_et_clipboard( "    texte_couleur_1 = couleur_texte | $FF000000 "  )
    ajoute_a_editor_et_clipboard( "  endif")
    ajoute_a_editor_et_clipboard( "  If couleur_fond_texte <> 0" )
    ajoute_a_editor_et_clipboard( "    texte_couleur_2 = couleur_fond_texte | $FF000000 "  )
    ajoute_a_editor_et_clipboard( "  endif")
    ajoute_a_editor_et_clipboard( "  DrawText(centrage_x , centrage_y , txt_compile , texte_couleur_1 , texte_couleur_2) " )
    ajoute_a_editor_et_clipboard( "  StopDrawing()" )
    ajoute_a_editor_et_clipboard( "  FreeFont(#font_tempo)" )
    ajoute_a_editor_et_clipboard( "EndProcedure")
    ajoute_a_editor_et_clipboard( "")
  EndIf
  
  ; procedure fenetre principale
  ajoute_a_editor_et_clipboard( "; Fenetre principale")
  ajoute_a_editor_et_clipboard( "Procedure Open_Window()")
  ForEach code_fenetre()
    ajoute_a_editor_et_clipboard( "  " + code_fenetre())
  Next
  ajoute_a_editor_et_clipboard( "EndProcedure")
  
  ajoute_a_editor_et_clipboard( "")
  ajoute_a_editor_et_clipboard( "")
  ajoute_a_editor_et_clipboard( "")
  If rajoute_proc_image = 1
    ajoute_a_editor_et_clipboard( "; appel pour les boutons images")
    ForEach code_image_bouton()
      ajoute_a_editor_et_clipboard( "  " + code_image_bouton())
    Next
    ;ajoute_a_editor_et_clipboard( "image_bouton()")
  EndIf
  ajoute_a_editor_et_clipboard( "; appel a la fenetre")
  ajoute_a_editor_et_clipboard( "Open_Window()")
  ajoute_a_editor_et_clipboard( "")
  ajoute_a_editor_et_clipboard( "; boucle principale")
  ajoute_a_editor_et_clipboard( "Repeat")
  ajoute_a_editor_et_clipboard( "  Event = WaitWindowEvent()")
  ajoute_a_editor_et_clipboard( "  Eventgadget = EventGadget()")
  ajoute_a_editor_et_clipboard( "  EventType = EventType()")
  ; clic gauche windows
  If window_action(0) = 1
    ajoute_a_editor_et_clipboard( "  If event = #PB_Event_LeftClick")
    ajoute_a_editor_et_clipboard( "    window_clic_gauche(" + Enumerations_window() + ")" )
    ajoute_a_editor_et_clipboard( "  EndIf")
  EndIf
  ; clic droit windows
  If window_action(1) = 1
    ajoute_a_editor_et_clipboard( "  If event = #PB_Event_RightClick")
    ajoute_a_editor_et_clipboard( "    window_clic_droit(" + Enumerations_window() + ")" )
    ajoute_a_editor_et_clipboard( "  EndIf")
  EndIf
  
  ajoute_a_editor_et_clipboard( "  If event = #PB_Event_CloseWindow")
  ajoute_a_editor_et_clipboard( "    CloseWindow(" + Enumerations_window() + ")" )
  ajoute_a_editor_et_clipboard( "  EndIf")
  
  ajoute_a_editor_et_clipboard( "Forever")
  
  SetClipboardText( copie_clipboard$ )
  
  SelectElement( Gadget_2() , old_element )
EndProcedure

Procedure test_type(type$)
  If type$ = "window" ; a charger windows
    If IsWindow(#Window_de_dessin)
      CloseWindow(#Window_de_dessin)
    EndIf
    Gadget_2()\numero = OpenWindow(#Window_de_dessin, lit_nombre_list_gadget_sous("pos_x"), lit_nombre_list_gadget_sous("pos_y"), lit_nombre_list_gadget_sous("largeur"), lit_nombre_list_gadget_sous("hauteur"), lit_string_list_gadget_sous("txt_compile"), #PB_Window_SystemMenu|#PB_Window_SizeGadget|#PB_Window_MinimizeGadget|#PB_Window_TitleBar)
    rajoute_a_list_gadget_sous("numero",Str(Gadget_2()\numero) )
    creer_propriete("window")
  ElseIf type$ = "bouton"
    Gadget_2()\numero = ButtonImageGadget(#PB_Any,lit_nombre_list_gadget_sous("pos_x"), lit_nombre_list_gadget_sous("pos_y"), lit_nombre_list_gadget_sous("largeur"), lit_nombre_list_gadget_sous("hauteur"),0 )
    rajoute_a_list_gadget_sous("numero",Str(Gadget_2()\numero) )
    redessine_image_bouton()
    entoure_gadget()
    SetGadgetAttribute(Gadget_2()\numero , #PB_Button_Image , ImageID(#image_normale))
    ImageGadget(#bouton_contour, 0, 0, 50, 25, 0 )
    HideGadget(#bouton_contour , 1)
  EndIf
EndProcedure

Procedure.s test_caracteres_interdits(gadget , txt$)
  Protected renvoi$ = ""
  Protected position_x
  SendMessage_(GadgetID(Gadget),#EM_GETSEL,@Min,@Max)
  position_x = Max-SendMessage_(GadgetID(Gadget),#EM_LINEINDEX,SendMessage_(GadgetID(Gadget),#EM_LINEFROMCHAR,Min,0),0)
  For text_carac = 1 To Len( txt$ )
    tmp_carac.s = Mid( txt$ , text_carac , 1)
    If Asc(tmp_carac) = 35 Or Asc(tmp_carac) = 95 Or (Asc(tmp_carac) >= 48 And Asc(tmp_carac) <= 57) Or (Asc(tmp_carac) >= 65 And Asc(tmp_carac) <= 90) Or (Asc(tmp_carac) >= 97 And Asc(tmp_carac) <= 122)
      renvoi$ + tmp_carac
    Else
      position_x - 1
    EndIf
  Next
  SetGadgetText(gadget , renvoi$)
  SendMessage_(GadgetID(gadget), #EM_SETSEL, position_x, position_x)
  ProcedureReturn renvoi$
EndProcedure

lit_fichier_config()

OpenWindow_Window_de_dessin()
OpenWindow_Window_gadgets()
OpenWindow_Window_propriete()
OpenWindow_Window_editor()

creer_propriete("window")

SetWindowCallback(@Callback() )

dragging = 0
Global curseur_en_cours = #IDC_ARROW

Repeat
  ; changer le curseur si dans zone selectionnable
  If GetActiveWindow() = #Window_de_dessin
    If (WindowMouseX(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_x") - 4) And WindowMouseX(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_x") - 1)) Or (WindowMouseX(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_x") + lit_nombre_list_gadget_sous("largeur") + 1) And WindowMouseX(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_x") + lit_nombre_list_gadget_sous("largeur") + 4)) Or (WindowMouseY(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_y") - 4) And WindowMouseY(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_y") - 1)) Or (WindowMouseY(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_y") + lit_nombre_list_gadget_sous("hauteur") + 1) And WindowMouseY(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_y") + lit_nombre_list_gadget_sous("hauteur") + 4))
      SetCursor_(LoadCursor_(0,#IDC_CROSS))
      curseur_en_cours = #IDC_CROSS
    ElseIf curseur_en_cours <> #IDC_ARROW
      SetCursor_(LoadCursor_(0,#IDC_ARROW))
      curseur_en_cours = #IDC_ARROW      
    EndIf
  EndIf
  
  If GetAsyncKeyState_(#PB_Shortcut_Left)  & 32768 And IsThread(numero_thread_clignotant)
    rajoute_a_list_gadget_sous("pos_x" , Str(lit_nombre_list_gadget_sous("pos_x") - 1)  )
    creer_propriete(lit_string_list_gadget_sous("type"))
    ResizeGadget( lit_nombre_list_gadget_sous("numero") , lit_nombre_list_gadget_sous("pos_x") , #PB_Ignore , #PB_Ignore , #PB_Ignore)
    rendu = 1
    Delay(25)
   ElseIf GetAsyncKeyState_(#PB_Shortcut_Right)  & 32768 And IsThread(numero_thread_clignotant)
    rajoute_a_list_gadget_sous("pos_x" , Str(lit_nombre_list_gadget_sous("pos_x") + 1) )
    creer_propriete(lit_string_list_gadget_sous("type"))
    ResizeGadget( lit_nombre_list_gadget_sous("numero") , lit_nombre_list_gadget_sous("pos_x") , #PB_Ignore , #PB_Ignore , #PB_Ignore)
    rendu = 1
    Delay(25)
  ElseIf GetAsyncKeyState_(#PB_Shortcut_Up)  & 32768 And IsThread(numero_thread_clignotant)
    rajoute_a_list_gadget_sous("pos_y" ,Str(lit_nombre_list_gadget_sous("pos_y") - 1) )
    creer_propriete(lit_string_list_gadget_sous("type"))
    ResizeGadget( lit_nombre_list_gadget_sous("numero") , #PB_Ignore , lit_nombre_list_gadget_sous("pos_y") , #PB_Ignore , #PB_Ignore)
    rendu = 1
    Delay(25)
  ElseIf GetAsyncKeyState_(#PB_Shortcut_Down)  & 32768 And IsThread(numero_thread_clignotant)
    rajoute_a_list_gadget_sous("pos_y" ,Str(lit_nombre_list_gadget_sous("pos_y") + 1) )
    creer_propriete(lit_string_list_gadget_sous("type"))
    ResizeGadget( lit_nombre_list_gadget_sous("numero") , #PB_Ignore , lit_nombre_list_gadget_sous("pos_y") , #PB_Ignore , #PB_Ignore)
    rendu = 1
    Delay(25)
  EndIf
  
  Event = WaitWindowEvent(5)
  EventGadget = EventGadget()
  
  ; /////////////////// deplace fenetres
  If event = #PB_Event_MoveWindow
    If GetActiveWindow() = #Window_gadgets Or GetActiveWindow() = #Window_editor Or GetActiveWindow() = #Window_propriete
      ecrit_fichier_config()
    EndIf
    If GetActiveWindow() = #Window_de_dessin
      SelectElement( Gadget_2() , 0)
      rajoute_a_list_gadget_sous("pos_x" , Str(WindowX(#Window_de_dessin)) )
      rajoute_a_list_gadget_sous("pos_y" , Str(WindowY(#Window_de_dessin)) )
      creer_propriete("window")
    EndIf
  ; /////////////////// redimensionnes fenetres
  ElseIf event = #PB_Event_SizeWindow
    If GetActiveWindow() = #Window_gadgets Or GetActiveWindow() = #Window_editor Or GetActiveWindow() = #Window_propriete
      ecrit_fichier_config()
    EndIf
    ; /////////////////// redimensionne fenetre principale
    If GetActiveWindow() = #Window_de_dessin
      rajoute_a_list_gadget_sous("largeur" , Str(WindowWidth( #Window_de_dessin)) )
      rajoute_a_list_gadget_sous("hauteur" , Str(WindowHeight(#Window_de_dessin)) )
      creer_propriete("window")
    EndIf
    If GetActiveWindow() = #Window_editor
      ResizeGadget( #Editor_editeur , 0,0, WindowWidth( #Window_editor) , WindowHeight( #Window_editor) - 35)
    EndIf
  ; /////////////////// souris enfoncée
  ElseIf event = #WM_LBUTTONDOWN
    ; si clique sur selection de gadget
    If gadget_en_cours >= 900 And gadget_en_cours < 1000
      If gadget_en_cours = #Button_Bouton
        type = "bouton"
      ElseIf gadget_en_cours = #Button_checkbox
        type = "checkbox"
      ElseIf gadget_en_cours = #Button_panel
        type = "panel"
      EndIf
      dragging=1
      retour_nom_font = ""

      ; copie bouton sur image
      If IsImage(#image_contour)
        FreeImage(#image_contour)
      EndIf
      StartDrawing(WindowOutput(#Window_gadgets) )
      GrabDrawingImage(#image_contour , 5, 5, 80, 25)
      StopDrawing()
      If StartDrawing(ImageOutput(#image_contour))
        DrawingMode(#PB_2DDrawing_AlphaChannel)
        Box(0, 0, ImageWidth(#image_contour), ImageHeight(#image_contour), $FF000000)
        StopDrawing()
      EndIf
      SetGadgetState(#bouton_contour , ImageID(#image_contour))
    EndIf
    
    ; clic sur un gadget deposé
    If dragging = 0 And trouve_gadget_2("numero" , Str(gadget_dessous) )
      wx = WindowMouseX(#Window_de_dessin)
      wy = WindowMouseY(#Window_de_dessin)
      If lit_nombre_list_gadget_sous("panel") = 0
        debut_x = GadgetX( lit_nombre_list_gadget_sous("numero") )
        fin_x = GadgetX( lit_nombre_list_gadget_sous("numero") ) + GadgetWidth( lit_nombre_list_gadget_sous("numero") )
        debut_y = GadgetY( lit_nombre_list_gadget_sous("numero") )
        fin_y = GadgetY( lit_nombre_list_gadget_sous("numero") ) + GadgetHeight( lit_nombre_list_gadget_sous("numero") )
      Else
        ; trouver panel
        garde_panel_a_trouver = lit_nombre_list_gadget_sous("panel")
        old_element = ListIndex( Gadget_2() )
        ForEach Gadget_2()
          If lit_nombre_list_gadget_sous("numero") = garde_panel_a_trouver
            rajout_panel_x = lit_nombre_list_gadget_sous("pos_x")
            rajout_panel_y = lit_nombre_list_gadget_sous("pos_y")
            numero_panel = garde_panel_a_trouver
            Break
          EndIf
        Next
        SelectElement( Gadget_2() , old_element )
        OpenGadgetList( garde_panel_a_trouver )
        panel_ouvert = garde_panel_a_trouver
        dans_panel = 1
        debut_x = GadgetX( lit_nombre_list_gadget_sous("numero") ) + rajout_panel_x
        fin_x = GadgetX( lit_nombre_list_gadget_sous("numero") ) + GadgetWidth( lit_nombre_list_gadget_sous("numero") ) + rajout_panel_x
        debut_y = GadgetY( lit_nombre_list_gadget_sous("numero") ) + rajout_panel_y + 20
        fin_y = GadgetY( lit_nombre_list_gadget_sous("numero") ) + GadgetHeight( lit_nombre_list_gadget_sous("numero") ) + rajout_panel_y + 20
      EndIf
      
      ; ///// deplacement gadget
      If wx >= debut_x + 4 And wx <= fin_x - 4 And wy >= debut_y + 4 And wy <= fin_y - 4
        x_moins = WindowMouseX(#Window_de_dessin) - GadgetX(lit_nombre_list_gadget_sous("numero") )
        y_moins = WindowMouseY(#Window_de_dessin) - GadgetY(lit_nombre_list_gadget_sous("numero") )
        deplacement_gadget = 1
      EndIf
      
    EndIf

    
    ; ///// redimensionne gadget (hors zone gadget)
    If redimensionne_gadget = 0 And ((WindowMouseX(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_x") - 4) And WindowMouseX(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_x") - 1)) Or (WindowMouseX(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_x") + lit_nombre_list_gadget_sous("largeur") + 1) And WindowMouseX(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_x") + lit_nombre_list_gadget_sous("largeur") + 4)) Or (WindowMouseY(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_y") - 4) And WindowMouseY(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_y") - 1)) Or (WindowMouseY(#Window_de_dessin) >= (lit_nombre_list_gadget_sous("pos_y") + lit_nombre_list_gadget_sous("hauteur") + 1) And WindowMouseY(#Window_de_dessin) <= (lit_nombre_list_gadget_sous("pos_y") + lit_nombre_list_gadget_sous("hauteur") + 4)))
      redimensionne_gadget = 1
      ailleurs = 1
    EndIf

    
    ; /////////////////// relache bouton souris
  ElseIf event = #WM_LBUTTONUP
    ; si clique sur la fenetre
    If redimensionne_gadget = 0 And gadget_en_cours = 0 And GetActiveWindow() = #Window_de_dessin
      type = "window"
      If dans_panel = 1
        CloseGadgetList()
        panel_ouvert = 0
        dans_panel = 0
      EndIf
      SelectElement( gadget_2() , 0)
      entoure_gadget(0)
      creer_propriete("window")
    EndIf
    
    ; si depose gadget
    gadget_en_cours = 0
    If WindowMouseX(#Window_de_dessin) > 0 And WindowMouseX(#Window_de_dessin) < WindowWidth(#Window_de_dessin) And WindowMouseY(#Window_de_dessin) > 0 And WindowMouseY(#Window_de_dessin) < WindowHeight(#Window_de_dessin)
      UseGadgetList( WindowID(#Window_de_dessin) )
      If dragging=1
        If dans_panel = 1
          old_x = lit_nombre_list_gadget_sous("pos_x")
          old_y = lit_nombre_list_gadget_sous("pos_y")
        Else
          old_x = 0
          old_y = 0
        EndIf
        If type = "bouton"
          AddElement( gadget_2() )
          rajoute_a_list_gadget_sous("type" , type )
          rajoute_a_list_gadget_sous("largeur" , "80" )
          rajoute_a_list_gadget_sous("hauteur" , "25" )
          rajoute_a_list_gadget_sous("txt_compile" , type )
          rajoute_a_list_gadget_sous("centrage_largeur" , "2" )
          rajoute_a_list_gadget_sous("centrage_hauteur" , "2" )
          rajoute_a_list_gadget_sous("couleur_fond_gadget" , Str(GetSysColor_(#COLOR_BTNFACE)) )
          rajoute_a_list_gadget_sous("couleur_fond_texte" , Str(GetSysColor_(#COLOR_BTNFACE)) )
          If dans_panel = 0
            tmp = ButtonImageGadget(#PB_Any,WindowMouseX(#Window_de_dessin),WindowMouseY(#Window_de_dessin),80,25,0 )
          Else
            tmp = ButtonImageGadget(#PB_Any,WindowMouseX(#Window_de_dessin) - old_x,WindowMouseY(#Window_de_dessin) - old_y ,80,25,0 )
            rajoute_a_list_gadget_sous("panel" , Str(numero_panel) )
          EndIf
          rajoute_a_list_gadget_sous("numero" , Str(tmp) )
          rajoute_a_list_gadget_sous("nom_compile" , "#bouton_" + lit_string_list_gadget_sous("numero") )
          rajoute_a_list_gadget_sous("pos_x" , Str(GadgetX(lit_nombre_list_gadget_sous("numero") )) )
          rajoute_a_list_gadget_sous("pos_y" , Str(GadgetY(lit_nombre_list_gadget_sous("numero") )) )
          rajoute_a_list_gadget_sous("font_nom" , "MS Sans Serif" )
          rajoute_a_list_gadget_sous("font_taille" , "8" )
          rajoute_a_list_gadget_sous("font_style" , "0" )
          redessine_image_bouton()
          entoure_gadget()
          creer_propriete("bouton")
          old_gadget = ListIndex(gadget_2())
        ElseIf type = "checkbox"
          AddElement( gadget_2() )
          rajoute_a_list_gadget_sous("type" , type )
          rajoute_a_list_gadget_sous("largeur" , "80" )
          rajoute_a_list_gadget_sous("hauteur" , "25" )
          rajoute_a_list_gadget_sous("txt_compile" , type )
          If dans_panel = 0
            tmp = CheckBoxGadget(#PB_Any,WindowMouseX(#Window_de_dessin),WindowMouseY(#Window_de_dessin),80,25, type )
          Else
            tmp = CheckBoxGadget(#PB_Any,WindowMouseX(#Window_de_dessin) - old_x,WindowMouseY(#Window_de_dessin) - old_y,80,25, type )
            rajoute_a_list_gadget_sous("panel" , Str(tmp) )
          EndIf
          rajoute_a_list_gadget_sous("numero" , Str(tmp) )
          rajoute_a_list_gadget_sous("nom_compile" , "#checkbox_" + lit_string_list_gadget_sous("numero") )
          rajoute_a_list_gadget_sous("pos_x" , Str(GadgetX(lit_nombre_list_gadget_sous("numero") )) )
          rajoute_a_list_gadget_sous("pos_y" , Str(GadgetY(lit_nombre_list_gadget_sous("numero") )) )
          rajoute_a_list_gadget_sous("font_nom" , "MS Sans Serif" )
          rajoute_a_list_gadget_sous("font_taille" , "8" )
          rajoute_a_list_gadget_sous("font_style" , "0" )
          entoure_gadget()
          creer_propriete("checkbox")
          old_gadget = ListIndex(gadget_2())
        ElseIf type = "panel"
          AddElement( gadget_2() )
          rajoute_a_list_gadget_sous("type" , type )
          rajoute_a_list_gadget_sous("largeur" , "200" )
          rajoute_a_list_gadget_sous("hauteur" , "200" )
          rajoute_a_list_gadget_sous("txt_compile" , type )
          If dans_panel = 0
            tmp = PanelGadget(#PB_Any,WindowMouseX(#Window_de_dessin),WindowMouseY(#Window_de_dessin),200,200 )
          Else
            tmp = PanelGadget(#PB_Any,WindowMouseX(#Window_de_dessin)- old_x ,WindowMouseY(#Window_de_dessin)- old_y - 20,200,200 )
            rajoute_a_list_gadget_sous("panel" , Str(tmp) )
          EndIf 
          AddGadgetItem(tmp,-1,"1")
          rajoute_a_list_gadget_sous("numero" , Str(tmp) )
          rajoute_a_list_gadget_sous("nom_compile" , "#checkbox_" + lit_string_list_gadget_sous("numero") )
          rajoute_a_list_gadget_sous("pos_x" , Str(GadgetX(lit_nombre_list_gadget_sous("numero") )) )
          rajoute_a_list_gadget_sous("pos_y" , Str(GadgetY(lit_nombre_list_gadget_sous("numero") )) )
          entoure_gadget()
          creer_propriete("panel")
          old_gadget = ListIndex(gadget_2())
          dans_panel = 1
          numero_panel = tmp
          
        EndIf
        HideGadget(#bouton_contour , 1)
        ResizeGadget(#bouton_contour , 0 , 0 , #PB_Ignore , #PB_Ignore)
      EndIf
      If type = "bouton"
        If redimensionne_gadget = 1
          redessine_image_bouton()
          entoure_gadget()
          creer_propriete("bouton")
        EndIf
      EndIf
    EndIf

    dragging = 0
    gauche_appuyer = 0
    deplacement_gadget = 0
    redimensionne_gadget = 0
    rends_code()   
    ; /////////////////// selectionne un gadget sur la fenetre de dessin
  ElseIf event = #PB_Event_Gadget
    EventGadget = EventGadget()
    EventType = EventType()
    
    ; //// clique sur gadget créé
    If GetActiveWindow() = #Window_de_dessin
      old_element = ListIndex( gadget_2() )
      ForEach Gadget_2()
        If EventGadget = lit_nombre_list_gadget_sous("numero")
          old_gadget = ListIndex( gadget_2() )
          If lit_string_list_gadget_sous("type") = "bouton"
            redessine_image_bouton()
            entoure_gadget()
            creer_propriete("bouton")
          ElseIf lit_string_list_gadget_sous("type") = "checkbox"
            entoure_gadget()
            creer_propriete("checkbox")
          ElseIf lit_string_list_gadget_sous("type") = "panel"
            If dans_panel = 1
              dans_panel = 0
              CloseGadgetList()
              panel_ouvert = 0
              ;entoure_gadget(0)
            EndIf
            entoure_gadget()
            creer_propriete("panel")
            numero_panel = lit_nombre_list_gadget_sous("numero")
            Debug "numero panel : " + numero_panel
            dans_panel = 1
            OpenGadgetList( numero_panel )
            panel_ouvert = numero_panel
          EndIf
          Break
        EndIf
      Next
      SelectElement( gadget_2() , old_element)
    EndIf
    
    ; //// clique sur propriete de gadget créé
    If GetActiveWindow() = #Window_propriete
      rendu = 0
      ForEach gadget_propriete()
        If EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_font" And EventType = #PB_EventType_LeftClick
          ; //// clique sur propriete FONTS
          If choix_fonts( lit_nombre_list_gadget_sous("numero") , #image_normale , lit_string_list_gadget_sous("txt_compile") , lit_nombre_list_gadget_sous("largeur"), lit_nombre_list_gadget_sous("hauteur"), lit_nombre_list_gadget_sous("centrage_largeur") , lit_nombre_list_gadget_sous("centrage_hauteur") , lit_string_list_gadget_sous("font_nom") , lit_nombre_list_gadget_sous("font_taille") , lit_nombre_list_gadget_sous("font_style") ) = 1
            rajoute_a_list_gadget_sous("font_nom" , retour_nom_font )
            rajoute_a_list_gadget_sous("font_style" , Str(retour_style_font) )
            rajoute_a_list_gadget_sous("font_taille" , Str(retour_taille_font) )
            rajoute_a_list_gadget_sous("couleur_fond_gadget" , Str(retour_couleur_fond_gadget) )
            rajoute_a_list_gadget_sous("couleur_fond_texte" , Str(retour_couleur_fond_texte) )
            rajoute_a_list_gadget_sous("couleur_texte" , Str(retour_couleur_texte) )
            change_texte("nom_font", retour_nom_font)
            If lit_string_list_gadget_sous("type") = "bouton"
              redessine_image_bouton()
              entoure_gadget()
            ElseIf lit_string_list_gadget_sous("type") = "checkbox"
              entoure_gadget()
              SetGadgetFont(lit_nombre_list_gadget_sous("numero"), FontID(LoadFont(#PB_Any, lit_string_list_gadget_sous("font_nom") , lit_nombre_list_gadget_sous("font_taille") , lit_nombre_list_gadget_sous("font_style"))))
            EndIf 
            rends_code()
          EndIf
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_Nom_du_gadget" And EventType = #PB_EventType_Change
          rajoute_a_list_gadget_sous("nom_compile" , test_caracteres_interdits(gadget_propriete()\numero_du_gadget, GetGadgetText( gadget_propriete()\numero_du_gadget ) ) )
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_Texte_dans_le_gadget"  And EventType = #PB_EventType_Change
          rajoute_a_list_gadget_sous("txt_compile" , GetGadgetText(gadget_propriete()\numero_du_gadget) )
          If lit_string_list_gadget_sous("type") = "bouton"
            SetGadgetText( lit_nombre_list_gadget_sous("numero") , lit_string_list_gadget_sous("txt_compile") )
            redessine_image_bouton()
            entoure_gadget()
          ElseIf lit_string_list_gadget_sous("type") = "window"
            SetWindowTitle(#Window_de_dessin , lit_string_list_gadget_sous("txt_compile") )
          ElseIf lit_string_list_gadget_sous("type") = "checkbox"
            entoure_gadget()
            SetGadgetText( lit_nombre_list_gadget_sous("numero") , lit_string_list_gadget_sous("txt_compile") )
          EndIf
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_centre_texte_largeur_gauche"
          rajoute_a_list_gadget_sous("centrage_largeur" , "1")
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_centre_texte_largeur_centre"
          rajoute_a_list_gadget_sous("centrage_largeur" , "2" )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_centre_texte_largeur_droite"
          rajoute_a_list_gadget_sous("centrage_largeur" , "3" )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_centre_texte_hauteur_haut"
          rajoute_a_list_gadget_sous("centrage_hauteur" , "1" )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_centre_texte_hauteur_centre"
          rajoute_a_list_gadget_sous("centrage_hauteur" , "2" )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_centre_texte_hauteur_bas"
          rajoute_a_list_gadget_sous("centrage_hauteur" , "3" )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "emplacement_x"
          rajoute_a_list_gadget_sous("pos_x" , GetGadgetText(gadget_propriete()\numero_du_gadget) )
          ResizeGadget( lit_nombre_list_gadget_sous("numero") , lit_nombre_list_gadget_sous("pos_x") , #PB_Ignore , #PB_Ignore , #PB_Ignore )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "emplacement_y"
          rajoute_a_list_gadget_sous("pos_y" , GetGadgetText(gadget_propriete()\numero_du_gadget) )
          ResizeGadget( lit_nombre_list_gadget_sous("numero") , #PB_Ignore , lit_nombre_list_gadget_sous("pos_y") , #PB_Ignore , #PB_Ignore )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "longueur_gadget" And Val(GetGadgetText(gadget_propriete()\numero_du_gadget)) <> 0
          rajoute_a_list_gadget_sous("largeur" , GetGadgetText(gadget_propriete()\numero_du_gadget) )
          ResizeGadget( lit_nombre_list_gadget_sous("numero") , #PB_Ignore , #PB_Ignore , lit_nombre_list_gadget_sous("largeur") , #PB_Ignore )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "hauteur_gadget" And Val(GetGadgetText(gadget_propriete()\numero_du_gadget)) <> 0
          rajoute_a_list_gadget_sous("hauteur" , GetGadgetText(gadget_propriete()\numero_du_gadget) )
          ResizeGadget( lit_nombre_list_gadget_sous("numero") , #PB_Ignore , #PB_Ignore , #PB_Ignore , lit_nombre_list_gadget_sous("hauteur") )
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_inactif"
          If GetGadgetState( EventGadget ) = #PB_Checkbox_Checked
            rajoute_a_list_gadget_sous("disable" , "1" )
          Else
            rajoute_a_list_gadget_sous("disable" , "0" )
          EndIf
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_invisible"
          If GetGadgetState( EventGadget ) = #PB_Checkbox_Checked
            rajoute_a_list_gadget_sous("invisible" , "1" )
          Else
            rajoute_a_list_gadget_sous("invisible" , "0" )
          EndIf
          rendu = 1
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_sansbord"
          If GetGadgetState( EventGadget ) = #PB_Checkbox_Checked
            rajoute_a_list_gadget_sous("sans_bord" , "1" )
          Else
            rajoute_a_list_gadget_sous("sans_bord" , "0" )
          EndIf
          rendu = 1
          
        ; choix d'une image
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_image" And Len(gadget_propriete()\nom_du_gadget) = Len("gadget_image")
          resultat$ = LCase(OpenFileRequester("Choix d'une image","","ficher image (ico,bmp,png,jpg,tga,tiff,exe,dll)|*.bmp;*.ico;*.png;*.jpg;*.tga;*.tiff;*.exe;*.dll",1))
          If resultat$ <> ""
            If GetExtensionPart( resultat$ ) = "bmp" Or GetExtensionPart( resultat$ ) = "png" Or GetExtensionPart( resultat$ ) = "jpg" Or GetExtensionPart( resultat$ ) = "tga" Or GetExtensionPart( resultat$ ) = "tiff" Or GetExtensionPart( resultat$ ) = "ico"
              rajoute_a_list_gadget_sous("nom_image" , resultat$ ) 
              rajoute_a_list_gadget_sous("type_image" , GetExtensionPart( resultat$ ) )
            ElseIf GetExtensionPart( resultat$ ) = "exe" Or GetExtensionPart( resultat$ ) = "dll"
              
            EndIf
            change_texte("gadget_texte_image" , GetFilePart(lit_string_list_gadget_sous("nom_image")) )
            If lit_string_list_gadget_sous("type") = "bouton"
              redessine_image_bouton()
              entoure_gadget()
            EndIf
            rendu = 1
          EndIf
          
        ; choix d'une image enfonce
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "gadget_image_enfonce" And Len(gadget_propriete()\nom_du_gadget) = Len("gadget_image_enfonce")
          resultat$ = LCase(OpenFileRequester("Choix d'une image","","ficher image (ico,bmp,png,jpg,tga,tiff,exe,dll)|*.bmp;*.ico;*.png;*.jpg;*.tga;*.tiff;*.exe;*.dll",1))
          If resultat$ <> ""
            If GetExtensionPart( resultat$ ) = "bmp" Or GetExtensionPart( resultat$ ) = "png" Or GetExtensionPart( resultat$ ) = "jpg" Or GetExtensionPart( resultat$ ) = "tga" Or GetExtensionPart( resultat$ ) = "tiff" Or GetExtensionPart( resultat$ ) = "ico"
              rajoute_a_list_gadget_sous("nom_image_enfonce" , resultat$ ) 
              rajoute_a_list_gadget_sous("type_image" , GetExtensionPart( resultat$ ) )
            ElseIf GetExtensionPart( resultat$ ) = "exe" Or GetExtensionPart( resultat$ ) = "dll"
              
            EndIf
            change_texte("gadget_texte_image_enfonce" , GetFilePart(resultat$) )
            rendu = 1
          EndIf
        ; case a cocher : image centrée
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "centrage_image"
          If GetGadgetState( EventGadget ) = #PB_Checkbox_Checked
            rajoute_a_list_gadget_sous("image_centre" , "1" )
          Else
            rajoute_a_list_gadget_sous("image_centre" , "0" )
          EndIf
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ; case a cocher : sans bord
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "plein_image"
          If GetGadgetState( EventGadget ) = #PB_Checkbox_Checked
            rajoute_a_list_gadget_sous("image_plein" , "1" )
          Else
            rajoute_a_list_gadget_sous("image_plein" , "0" )
          EndIf
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ; propriete windows
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "window_listbox_propriete" And EventType = #PB_EventType_Change
          For i_list = 0 To CountGadgetItems(EventGadget)
            If GetGadgetItemState(EventGadget , i_list) = #PB_ListIcon_Checked
              window_propriete(i_list) = 1
            Else
              window_propriete(i_list) = 0
            EndIf
          Next i_list
          rendu = 1
        ; actions windows
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "windows_listbox_action" And EventType = #PB_EventType_Change
          For i_list = 0 To CountGadgetItems(EventGadget)
            If GetGadgetItemState(EventGadget , i_list) = #PB_ListIcon_Checked
              window_action(i_list) = 1
            Else
              window_action(i_list) = 0
            EndIf
          Next i_list
          rendu = 1
        ; texte transparent
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "txt_transparent"
          If GetGadgetState( EventGadget ) = #PB_Checkbox_Checked
            rajoute_a_list_gadget_sous("txt_transparent" , "1" )
          Else
            rajoute_a_list_gadget_sous("txt_transparent" , "0" )
          EndIf
          redessine_image_bouton()
          entoure_gadget()
          rendu = 1
        ; couleur fond window
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "w_couleur_fond"
          resultat = ColorRequester()
          If resultat > -1
            retour_couleur_texte = resultat
            SetWindowColor( #Window_de_dessin , resultat)
            rajoute_a_list_gadget_sous("w_couleur_fond", Str(resultat) )
            rendu = 1
          EndIf
        ; couleur fond window
        ElseIf EventGadget = gadget_propriete()\numero_du_gadget And gadget_propriete()\nom_du_gadget = "pre-cocher"
          If GetGadgetState( EventGadget ) = #PB_Checkbox_Checked
            rajoute_a_list_gadget_sous("pre-cocher" , "1")
          Else
            rajoute_a_list_gadget_sous("pre-cocher" , "2")
          EndIf
          rendu = 1
          
          
        EndIf
      Next
      If rendu = 1
        rends_code()
      EndIf
    EndIf ; fin activegadget() = #window_propriete
    
  ; //  fin eventgadget   //
  ; ////////////////////////
  ElseIf event = #PB_Event_CloseWindow
    EventWindow = EventWindow()
    If EventWindow = #Window_de_dessin Or EventWindow = #Window_gadgets Or EventWindow = #Window_propriete
      CloseWindow(#Window_de_dessin)
      CloseWindow(#Window_gadgets)
      CloseWindow(#Window_propriete)
      CloseWindow(#Window_editor)
      End
    EndIf
    
  ; //  fin closewindows  //
  ; ////////////////////////
  ElseIf event = #PB_Event_Menu
    Select EventMenu()
      Case 1 ; charger
        resultat$ = OpenFileRequester("Chargement d'un projet","","(*.hlmpb)|*.hlmpb",0)
        If resultat$ <> "" And ReadFile(#fichier_sauvegarde , resultat$)
          nom_de_sauvegarde$ = resultat$
          ClearList( Gadget_2()\sous() )
          ClearList( Gadget_2() )
          i = 0
          type$ = ""
          While Eof(#fichier_sauvegarde) = 0
            tmp$ = ReadString( #fichier_sauvegarde )
            If StringField(tmp$ , 1 , Chr(9) ) = "type"
              test_type(type$)
              type$ = StringField(tmp$ , 2 , Chr(9) )
              AddElement( Gadget_2() )
            EndIf
            rajoute_a_list_gadget_sous( StringField(tmp$ , 1 , Chr(9) ) , StringField(tmp$ , 2 , Chr(9) ) )
          Wend
          test_type(type$)
          CloseFile(#fichier_sauvegarde)
        EndIf
        
      Case 2 ; sauver
        If nom_de_sauvegarde$ = ""
          Goto va_case_3
        EndIf
        If CreateFile(#fichier_sauvegarde , nom_de_sauvegarde$)
          ForEach Gadget_2()
            ForEach Gadget_2()\sous()
              WriteStringN(#fichier_sauvegarde , Gadget_2()\sous()\nom + Chr(9) + Gadget_2()\sous()\valeur)
            Next
          Next
          CloseFile(#fichier_sauvegarde)
        EndIf
        
      Case 3 ; sauver sous
        va_case_3:
        resultat$ = SaveFileRequester("sauvegarder le projet","","*.hlmpb",0)
        If resultat$ <> ""
          If CreateFile(#fichier_sauvegarde , resultat$ + ".hlmpb" )
            ForEach Gadget_2()
              ForEach Gadget_2()\sous()
                WriteStringN(#fichier_sauvegarde , Gadget_2()\sous()\nom + Chr(9) + Gadget_2()\sous()\valeur)
              Next
            Next
            CloseFile(#fichier_sauvegarde)
          EndIf
        EndIf
        
    EndSelect
    
  EndIf
  
  ; drag and drop d'un gadget
  If dragging = 1
    If WindowMouseX(#Window_de_dessin) <> -1 And WindowMouseY(#Window_de_dessin) <> -1
      HideGadget(#bouton_contour , 0)
      ResizeGadget(#bouton_contour , WindowMouseX(#Window_de_dessin) , WindowMouseY(#Window_de_dessin) , #PB_Ignore , #PB_Ignore)
    EndIf
  EndIf
  
  ; deplace un gadget
  If deplacement_gadget = 1
    ResizeGadget(lit_nombre_list_gadget_sous("numero") , WindowMouseX(#Window_de_dessin) - x_moins , WindowMouseY(#Window_de_dessin) - y_moins , #PB_Ignore , #PB_Ignore)
    rajoute_a_list_gadget_sous("pos_x" , Str(GadgetX( lit_nombre_list_gadget_sous("numero") )) )
    rajoute_a_list_gadget_sous("pos_y" , Str(GadgetY( lit_nombre_list_gadget_sous("numero") )) )
  EndIf
  
  ; redimensionne un gadget
  If redimensionne_gadget = 1
    If WindowMouseX(#Window_de_dessin) - GadgetX( lit_nombre_list_gadget_sous("numero")) > 0
      rajoute_a_list_gadget_sous("largeur" , Str( WindowMouseX(#Window_de_dessin) - GadgetX( lit_nombre_list_gadget_sous("numero")) ) )
    Else
      rajoute_a_list_gadget_sous("largeur" , "8" )
    EndIf
    If WindowMouseY(#Window_de_dessin) - GadgetY( lit_nombre_list_gadget_sous("numero")) > 0
      rajoute_a_list_gadget_sous("hauteur" , Str( WindowMouseY(#Window_de_dessin) - GadgetY( lit_nombre_list_gadget_sous("numero")) ) )
    Else
      rajoute_a_list_gadget_sous("hauteur" , "8" )
    EndIf
    ResizeGadget(lit_nombre_list_gadget_sous("numero") , #PB_Ignore , #PB_Ignore , lit_nombre_list_gadget_sous("largeur"), lit_nombre_list_gadget_sous("hauteur") )
    If lit_string_list_gadget_sous("type") = "bouton"
      redessine_image_bouton()
      entoure_gadget()
    EndIf
  EndIf
  
  fin_boucle:
ForEver

; IDE Options = PureBasic 5.42 LTS (Windows - x86)
; CursorPosition = 1351
; FirstLine = 749
; Folding = AIAQy
; EnableUnicode
; EnableThread
; EnableXP
; Executable = C:\Users\llemoine\Desktop\designer.exe
; EnableCompileCount = 1628
; EnableBuildCount = 2